/* Include files */

#include <stddef.h>
#include "blas.h"
#include "FeedbackLinearization_StateSpace_sfun.h"
#include "c2_FeedbackLinearization_StateSpace.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "FeedbackLinearization_StateSpace_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c2_debug_family_names[40] = { "l", "rb", "rp", "mb", "mp",
  "g", "Ib", "Ip", "m11", "m12", "m22", "T", "U", "E0", "J_tot", "T_pc", "T_pg",
  "T_ptau", "kp", "kd", "beta_1", "beta_2", "LQR_lim_x1", "LQR_lim_x2", "limit",
  "x_lim", "x1_lim", "x2_lim", "nargin", "nargout", "x", "t", "control_state",
  "tau", "u", "u0", "E_c", "E", "state", "LQR_control" };

static const char * c2_b_debug_family_names[11] = { "x1_max_lim", "x2_max_lim",
  "x1_LQR_lim", "x2_LQR_lim", "nargin", "nargout", "x", "limit", "LQR_state",
  "x_lim", "LQR_control" };

static const char * c2_c_debug_family_names[11] = { "x1_max_lim", "x2_max_lim",
  "x1_LQR_lim", "x2_LQR_lim", "nargin", "nargout", "x", "limit", "LQR_state",
  "x_lim", "LQR_control" };

/* Function Declarations */
static void initialize_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void initialize_params_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void enable_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void disable_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void c2_update_debugger_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static const mxArray *get_sim_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void set_sim_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_st);
static void finalize_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void sf_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void c2_chartstep_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void initSimStructsc2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void registerMessagesc2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static void c2_hysteresis(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance, real_T c2_x[6], real_T c2_limit[4], boolean_T c2_LQR_state,
  real_T c2_x_lim[2], real_T *c2_LQR_control);
static void c2_b_hysteresis(SFc2_FeedbackLinearization_StateSpaceInstanceStruct *
  chartInstance, real_T c2_x[6], real_T c2_limit[4], real_T c2_LQR_state, real_T
  c2_x_lim[2], real_T *c2_LQR_control);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData);
static real_T c2_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_LQR_control, const char_T *c2_identifier);
static real_T c2_b_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_c_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[2]);
static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static boolean_T c2_d_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_e_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[4]);
static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static const mxArray *c2_f_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static void c2_f_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[6]);
static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[57]);
static real_T c2_mpower(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance, real_T c2_a);
static void c2_eml_scalar_eg(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance);
static real_T c2_mod(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
                     *chartInstance, real_T c2_x, real_T c2_y);
static void c2_b_eml_scalar_eg
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);
static const mxArray *c2_g_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData);
static int32_T c2_g_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void c2_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData);
static uint8_T c2_h_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_b_is_active_c2_FeedbackLinearization_StateSpace, const char_T
   *c2_identifier);
static uint8_T c2_i_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId);
static void init_dsm_address_info
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  chartInstance->c2_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c2_is_active_c2_FeedbackLinearization_StateSpace = 0U;
}

static void initialize_params_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static void enable_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c2_update_debugger_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static const mxArray *get_sim_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  const mxArray *c2_st;
  const mxArray *c2_y = NULL;
  real_T c2_hoistedGlobal;
  real_T c2_u;
  const mxArray *c2_b_y = NULL;
  real_T c2_b_hoistedGlobal;
  real_T c2_b_u;
  const mxArray *c2_c_y = NULL;
  real_T c2_c_hoistedGlobal;
  real_T c2_c_u;
  const mxArray *c2_d_y = NULL;
  real_T c2_d_hoistedGlobal;
  real_T c2_d_u;
  const mxArray *c2_e_y = NULL;
  real_T c2_e_hoistedGlobal;
  real_T c2_e_u;
  const mxArray *c2_f_y = NULL;
  real_T c2_f_hoistedGlobal;
  real_T c2_f_u;
  const mxArray *c2_g_y = NULL;
  real_T c2_g_hoistedGlobal;
  real_T c2_g_u;
  const mxArray *c2_h_y = NULL;
  uint8_T c2_h_hoistedGlobal;
  uint8_T c2_h_u;
  const mxArray *c2_i_y = NULL;
  real_T *c2_E;
  real_T *c2_E_c;
  real_T *c2_LQR_control;
  real_T *c2_state;
  real_T *c2_tau;
  real_T *c2_i_u;
  real_T *c2_u0;
  c2_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c2_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c2_E = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_E_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_u0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_i_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_tau = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_st = NULL;
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(8), FALSE);
  c2_hoistedGlobal = *c2_E;
  c2_u = c2_hoistedGlobal;
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 0, c2_b_y);
  c2_b_hoistedGlobal = *c2_E_c;
  c2_b_u = c2_b_hoistedGlobal;
  c2_c_y = NULL;
  sf_mex_assign(&c2_c_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 1, c2_c_y);
  c2_c_hoistedGlobal = *c2_LQR_control;
  c2_c_u = c2_c_hoistedGlobal;
  c2_d_y = NULL;
  sf_mex_assign(&c2_d_y, sf_mex_create("y", &c2_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 2, c2_d_y);
  c2_d_hoistedGlobal = *c2_state;
  c2_d_u = c2_d_hoistedGlobal;
  c2_e_y = NULL;
  sf_mex_assign(&c2_e_y, sf_mex_create("y", &c2_d_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 3, c2_e_y);
  c2_e_hoistedGlobal = *c2_tau;
  c2_e_u = c2_e_hoistedGlobal;
  c2_f_y = NULL;
  sf_mex_assign(&c2_f_y, sf_mex_create("y", &c2_e_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 4, c2_f_y);
  c2_f_hoistedGlobal = *c2_i_u;
  c2_f_u = c2_f_hoistedGlobal;
  c2_g_y = NULL;
  sf_mex_assign(&c2_g_y, sf_mex_create("y", &c2_f_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 5, c2_g_y);
  c2_g_hoistedGlobal = *c2_u0;
  c2_g_u = c2_g_hoistedGlobal;
  c2_h_y = NULL;
  sf_mex_assign(&c2_h_y, sf_mex_create("y", &c2_g_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 6, c2_h_y);
  c2_h_hoistedGlobal =
    chartInstance->c2_is_active_c2_FeedbackLinearization_StateSpace;
  c2_h_u = c2_h_hoistedGlobal;
  c2_i_y = NULL;
  sf_mex_assign(&c2_i_y, sf_mex_create("y", &c2_h_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c2_y, 7, c2_i_y);
  sf_mex_assign(&c2_st, c2_y, FALSE);
  return c2_st;
}

static void set_sim_state_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T *c2_E;
  real_T *c2_E_c;
  real_T *c2_LQR_control;
  real_T *c2_state;
  real_T *c2_tau;
  real_T *c2_b_u;
  real_T *c2_u0;
  c2_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c2_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c2_E = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_E_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_u0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_b_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_tau = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c2_doneDoubleBufferReInit = TRUE;
  c2_u = sf_mex_dup(c2_st);
  *c2_E = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 0)),
    "E");
  *c2_E_c = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 1)),
    "E_c");
  *c2_LQR_control = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c2_u, 2)), "LQR_control");
  *c2_state = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u,
    3)), "state");
  *c2_tau = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 4)),
    "tau");
  *c2_b_u = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 5)),
    "u");
  *c2_u0 = c2_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 6)),
    "u0");
  chartInstance->c2_is_active_c2_FeedbackLinearization_StateSpace =
    c2_h_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c2_u, 7)),
    "is_active_c2_FeedbackLinearization_StateSpace");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_FeedbackLinearization_StateSpace(chartInstance);
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static void sf_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  int32_T c2_i0;
  real_T *c2_t;
  real_T *c2_tau;
  real_T *c2_u;
  real_T *c2_u0;
  real_T *c2_E_c;
  real_T *c2_E;
  real_T *c2_state;
  real_T *c2_control_state;
  real_T *c2_LQR_control;
  real_T (*c2_x)[6];
  c2_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c2_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c2_E = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_E_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_u0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_tau = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_x = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  for (c2_i0 = 0; c2_i0 < 6; c2_i0++) {
    _SFD_DATA_RANGE_CHECK((*c2_x)[c2_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c2_t, 1U);
  _SFD_DATA_RANGE_CHECK(*c2_tau, 2U);
  _SFD_DATA_RANGE_CHECK(*c2_u, 3U);
  _SFD_DATA_RANGE_CHECK(*c2_u0, 4U);
  _SFD_DATA_RANGE_CHECK(*c2_E_c, 5U);
  _SFD_DATA_RANGE_CHECK(*c2_E, 6U);
  _SFD_DATA_RANGE_CHECK(*c2_state, 7U);
  _SFD_DATA_RANGE_CHECK(*c2_control_state, 8U);
  _SFD_DATA_RANGE_CHECK(*c2_LQR_control, 9U);
  chartInstance->c2_sfEvent = CALL_EVENT;
  c2_chartstep_c2_FeedbackLinearization_StateSpace(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_FeedbackLinearization_StateSpaceMachineNumber_, chartInstance->chartNumber,
     chartInstance->instanceNumber);
}

static void c2_chartstep_c2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
  real_T c2_hoistedGlobal;
  real_T c2_b_hoistedGlobal;
  int32_T c2_i1;
  real_T c2_x[6];
  real_T c2_t;
  real_T c2_control_state;
  uint32_T c2_debug_family_var_map[40];
  real_T c2_l;
  real_T c2_rb;
  real_T c2_rp;
  real_T c2_mb;
  real_T c2_mp;
  real_T c2_g;
  real_T c2_Ib;
  real_T c2_Ip;
  real_T c2_m11;
  real_T c2_m12;
  real_T c2_m22;
  real_T c2_T;
  real_T c2_U;
  real_T c2_E0;
  real_T c2_J_tot;
  real_T c2_T_pc;
  real_T c2_T_pg;
  real_T c2_T_ptau;
  real_T c2_kp;
  real_T c2_kd;
  real_T c2_beta_1;
  real_T c2_beta_2;
  real_T c2_LQR_lim_x1;
  real_T c2_LQR_lim_x2;
  real_T c2_limit[4];
  real_T c2_x_lim[2];
  real_T c2_x1_lim;
  real_T c2_x2_lim;
  real_T c2_nargin = 3.0;
  real_T c2_nargout = 7.0;
  real_T c2_tau;
  real_T c2_u;
  real_T c2_u0;
  real_T c2_E_c;
  real_T c2_E;
  real_T c2_state;
  real_T c2_LQR_control;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_b;
  real_T c2_y;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_b_b;
  real_T c2_b_y;
  real_T c2_c_b;
  real_T c2_c_y;
  real_T c2_a;
  real_T c2_d_b;
  real_T c2_d_y;
  real_T c2_b_a;
  real_T c2_e_b;
  real_T c2_e_y;
  real_T c2_c_a;
  real_T c2_f_b;
  real_T c2_f_y;
  real_T c2_g_b;
  real_T c2_g_y;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_h_b;
  real_T c2_h_y;
  real_T c2_h_x;
  real_T c2_i_x;
  real_T c2_i_b;
  real_T c2_i_y;
  real_T c2_j_x;
  real_T c2_k_x;
  real_T c2_j_b;
  real_T c2_j_y;
  real_T c2_l_x;
  real_T c2_m_x;
  real_T c2_k_b;
  real_T c2_k_y;
  real_T c2_l_b;
  real_T c2_l_y;
  real_T c2_n_x;
  real_T c2_o_x;
  real_T c2_m_b;
  real_T c2_m_y;
  real_T c2_d_a;
  real_T c2_n_b;
  real_T c2_n_y;
  real_T c2_e_a;
  real_T c2_o_b;
  real_T c2_p_x;
  real_T c2_q_x;
  real_T c2_p_b;
  real_T c2_o_y;
  real_T c2_q_b;
  real_T c2_p_y;
  real_T c2_r_x;
  real_T c2_s_x;
  real_T c2_f_a;
  real_T c2_r_b;
  real_T c2_q_y;
  real_T c2_t_x;
  real_T c2_u_x;
  real_T c2_v_x;
  real_T c2_w_x;
  real_T c2_g_a;
  real_T c2_s_b;
  real_T c2_r_y;
  real_T c2_t_b;
  real_T c2_x_x;
  real_T c2_y_x;
  real_T c2_u_b;
  real_T c2_s_y;
  int32_T c2_i2;
  static real_T c2_dv0[4] = { 0.52359877559829882, 1.7453292519943295,
    0.010471975511965976, 0.020943951023931952 };

  int32_T c2_i3;
  real_T c2_ab_x[6];
  int32_T c2_i4;
  real_T c2_dv1[4];
  real_T c2_b_LQR_control;
  real_T c2_b_x_lim[2];
  int32_T c2_i5;
  int32_T c2_i6;
  real_T c2_bb_x[6];
  int32_T c2_i7;
  real_T c2_dv2[4];
  real_T c2_c_LQR_control;
  int32_T c2_i8;
  real_T c2_cb_x;
  real_T c2_db_x;
  real_T c2_t_y;
  real_T c2_eb_x;
  real_T c2_fb_x;
  real_T c2_u_y;
  real_T c2_gb_x[4];
  int32_T c2_i9;
  real_T c2_v_b[4];
  int32_T c2_k;
  int32_T c2_b_k;
  static real_T c2_dv3[4] = { 975.6281, 57.2364, 227.3441, 19.7419 };

  real_T c2_w_b;
  real_T c2_v_y;
  real_T c2_x_b;
  real_T c2_w_y;
  real_T c2_h_a;
  real_T c2_y_b;
  real_T c2_x_y;
  real_T c2_A;
  real_T c2_B;
  real_T c2_hb_x;
  real_T c2_y_y;
  real_T c2_ib_x;
  real_T c2_ab_y;
  real_T *c2_b_t;
  real_T *c2_b_control_state;
  real_T *c2_b_tau;
  real_T *c2_b_u;
  real_T *c2_b_u0;
  real_T *c2_b_E_c;
  real_T *c2_b_E;
  real_T *c2_b_state;
  real_T *c2_d_LQR_control;
  real_T (*c2_jb_x)[6];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  c2_d_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
  c2_b_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c2_b_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
  c2_b_E = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
  c2_b_E_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
  c2_b_u0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c2_b_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c2_b_tau = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c2_b_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c2_jb_x = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
  c2_hoistedGlobal = *c2_b_t;
  c2_b_hoistedGlobal = *c2_b_control_state;
  for (c2_i1 = 0; c2_i1 < 6; c2_i1++) {
    c2_x[c2_i1] = (*c2_jb_x)[c2_i1];
  }

  c2_t = c2_hoistedGlobal;
  c2_control_state = c2_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 40U, 40U, c2_debug_family_names,
    c2_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_l, 0U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_rb, 1U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_rp, 2U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_mb, 3U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_mp, 4U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_g, 5U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_Ib, 6U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_Ip, 7U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_m11, 8U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_m12, 9U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_m22, 10U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_T, 11U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_U, 12U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_E0, 13U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_J_tot, 14U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_T_pc, 15U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_T_pg, 16U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_T_ptau, 17U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_kp, 18U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_kd, 19U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_beta_1, 20U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_beta_2, 21U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_LQR_lim_x1, 22U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_LQR_lim_x2, 23U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_limit, 24U, c2_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x_lim, 25U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x1_lim, 26U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x2_lim, 27U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargin, 28U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargout, 29U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c2_x, 30U, c2_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_t, 31U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c2_control_state, 32U, c2_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_tau, 33U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_u, 34U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_u0, 35U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_E_c, 36U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_E, 37U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_state, 38U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_LQR_control, 39U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 6);
  c2_l = 0.72;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 7);
  c2_rb = 0.4;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 8);
  c2_rp = 0.2;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 9);
  c2_mb = 31.118;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 10);
  c2_mp = 5.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 11);
  c2_g = 9.81;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 12);
  c2_Ib = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 13);
  c2_Ip = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 16);
  c2_b_x = c2_x[1];
  c2_c_x = c2_b_x;
  c2_c_x = muDoubleScalarCos(c2_c_x);
  c2_b = c2_c_x;
  c2_y = 1.44 * c2_b;
  c2_m11 = ((((c2_Ib + c2_Ip) + 4.9788800000000011) + 2.5919999999999996) +
            0.20000000000000004) + c2_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 17);
  c2_d_x = c2_x[1];
  c2_e_x = c2_d_x;
  c2_e_x = muDoubleScalarCos(c2_e_x);
  c2_b_b = c2_e_x;
  c2_b_y = 0.72 * c2_b_b;
  c2_m12 = (c2_Ip + 0.20000000000000004) + c2_b_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 18);
  c2_m22 = 0.20000000000000004;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 20);
  c2_c_b = c2_m11;
  c2_c_y = 0.5 * c2_c_b;
  c2_a = c2_c_y;
  c2_d_b = c2_mpower(chartInstance, c2_x[2]);
  c2_d_y = c2_a * c2_d_b;
  c2_b_a = c2_m12;
  c2_e_b = c2_x[2];
  c2_e_y = c2_b_a * c2_e_b;
  c2_c_a = c2_e_y;
  c2_f_b = c2_x[3];
  c2_f_y = c2_c_a * c2_f_b;
  c2_g_b = c2_mpower(chartInstance, c2_x[3]);
  c2_g_y = 0.10000000000000002 * c2_g_b;
  c2_T = (c2_d_y + c2_f_y) + c2_g_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 21);
  c2_f_x = c2_x[0];
  c2_g_x = c2_f_x;
  c2_g_x = muDoubleScalarCos(c2_g_x);
  c2_h_b = c2_g_x;
  c2_h_y = 157.423032 * c2_h_b;
  c2_h_x = c2_x[0] + c2_x[1];
  c2_i_x = c2_h_x;
  c2_i_x = muDoubleScalarCos(c2_i_x);
  c2_i_b = c2_i_x;
  c2_i_y = 9.81 * c2_i_b;
  c2_U = c2_h_y + c2_i_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 22);
  c2_E = c2_T + c2_U;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 24);
  c2_E0 = 167.233032;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 25);
  c2_E_c = c2_E - c2_E0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 28);
  c2_j_x = c2_x[1];
  c2_k_x = c2_j_x;
  c2_k_x = muDoubleScalarSin(c2_k_x);
  c2_j_b = c2_mpower(chartInstance, c2_k_x);
  c2_j_y = 3.5999999999999996 * c2_j_b;
  c2_J_tot = 4.9788800000000011 + c2_j_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 31);
  c2_l_x = c2_x[1];
  c2_m_x = c2_l_x;
  c2_m_x = muDoubleScalarSin(c2_m_x);
  c2_k_b = c2_m_x;
  c2_k_y = -0.72 * c2_k_b;
  c2_l_b = c2_mpower(chartInstance, c2_x[2]);
  c2_l_y = 37.8544 * c2_l_b;
  c2_n_x = c2_x[1];
  c2_o_x = c2_n_x;
  c2_o_x = muDoubleScalarCos(c2_o_x);
  c2_m_b = c2_o_x;
  c2_m_y = 3.5999999999999996 * c2_m_b;
  c2_d_a = c2_m_y;
  c2_n_b = c2_mpower(chartInstance, c2_x[2]) + c2_mpower(chartInstance, c2_x[2]
    + c2_x[3]);
  c2_n_y = c2_d_a * c2_n_b;
  c2_e_a = c2_k_y;
  c2_o_b = (c2_mpower(chartInstance, c2_x[2] + c2_x[3]) + c2_l_y) + c2_n_y;
  c2_T_pc = c2_e_a * c2_o_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 33);
  c2_p_x = c2_x[1];
  c2_q_x = c2_p_x;
  c2_q_x = muDoubleScalarCos(c2_q_x);
  c2_p_b = c2_q_x;
  c2_o_y = 3.5999999999999996 * c2_p_b;
  c2_q_b = 1.0 + c2_o_y;
  c2_p_y = 4.4575555555555564 * c2_q_b;
  c2_r_x = c2_x[0];
  c2_s_x = c2_r_x;
  c2_s_x = muDoubleScalarSin(c2_s_x);
  c2_f_a = c2_p_y;
  c2_r_b = c2_s_x;
  c2_q_y = c2_f_a * c2_r_b;
  c2_t_x = c2_x[1];
  c2_u_x = c2_t_x;
  c2_u_x = muDoubleScalarCos(c2_u_x);
  c2_v_x = c2_x[0] + c2_x[1];
  c2_w_x = c2_v_x;
  c2_w_x = muDoubleScalarSin(c2_w_x);
  c2_g_a = 10.515111111111112 + c2_u_x;
  c2_s_b = c2_w_x;
  c2_r_y = c2_g_a * c2_s_b;
  c2_t_b = c2_q_y - c2_r_y;
  c2_T_pg = -35.316 * c2_t_b;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 35);
  c2_x_x = c2_x[1];
  c2_y_x = c2_x_x;
  c2_y_x = muDoubleScalarCos(c2_y_x);
  c2_u_b = c2_y_x;
  c2_s_y = 7.1999999999999993 * c2_u_b;
  c2_T_ptau = (25.8944 + c2_mpower(chartInstance, 3.5999999999999996)) + c2_s_y;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 38);
  c2_kp = 700.0;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 39);
  c2_kd = 24.330329056549974;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 43);
  c2_beta_1 = 0.52359877559829882;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 44);
  c2_beta_2 = 1.7453292519943295;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 46);
  c2_LQR_lim_x1 = 0.010471975511965976;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 47);
  c2_LQR_lim_x2 = 0.020943951023931952;
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 49);
  for (c2_i2 = 0; c2_i2 < 4; c2_i2++) {
    c2_limit[c2_i2] = c2_dv0[c2_i2];
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 50);
  if (CV_EML_IF(0, 1, 0, c2_t == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 51);
    for (c2_i3 = 0; c2_i3 < 6; c2_i3++) {
      c2_ab_x[c2_i3] = c2_x[c2_i3];
    }

    for (c2_i4 = 0; c2_i4 < 4; c2_i4++) {
      c2_dv1[c2_i4] = c2_dv0[c2_i4];
    }

    c2_hysteresis(chartInstance, c2_ab_x, c2_dv1, FALSE, c2_b_x_lim,
                  &c2_b_LQR_control);
    for (c2_i5 = 0; c2_i5 < 2; c2_i5++) {
      c2_x_lim[c2_i5] = c2_b_x_lim[c2_i5];
    }

    c2_LQR_control = c2_b_LQR_control;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 53);
    for (c2_i6 = 0; c2_i6 < 6; c2_i6++) {
      c2_bb_x[c2_i6] = c2_x[c2_i6];
    }

    for (c2_i7 = 0; c2_i7 < 4; c2_i7++) {
      c2_dv2[c2_i7] = c2_dv0[c2_i7];
    }

    c2_b_hysteresis(chartInstance, c2_bb_x, c2_dv2, c2_control_state, c2_b_x_lim,
                    &c2_c_LQR_control);
    for (c2_i8 = 0; c2_i8 < 2; c2_i8++) {
      c2_x_lim[c2_i8] = c2_b_x_lim[c2_i8];
    }

    c2_LQR_control = c2_c_LQR_control;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 56);
  c2_x1_lim = c2_x_lim[0];
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 57);
  c2_x2_lim = c2_x_lim[1];
  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 58);
  c2_cb_x = c2_x[0];
  c2_db_x = c2_cb_x;
  c2_t_y = muDoubleScalarAbs(c2_db_x);
  guard1 = FALSE;
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 0, c2_mod(chartInstance, c2_t_y, 6.2831853071795862) <=
                  c2_x1_lim)) {
    c2_eb_x = c2_x[1];
    c2_fb_x = c2_eb_x;
    c2_u_y = muDoubleScalarAbs(c2_fb_x);
    if (CV_EML_COND(0, 1, 1, c2_mod(chartInstance, c2_u_y, 6.2831853071795862) <=
                    c2_x2_lim)) {
      if (CV_EML_COND(0, 1, 2, c2_LQR_control == 1.0)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 1, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 59);
        c2_state = 2.0;
        _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 60);
        c2_u0 = 0.0;
        _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 61);
        c2_u = 0.0;
        _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 62);
        c2_gb_x[0] = c2_x[0];
        c2_gb_x[1] = c2_x[1];
        c2_gb_x[2] = c2_x[2];
        c2_gb_x[3] = c2_x[3];
        for (c2_i9 = 0; c2_i9 < 4; c2_i9++) {
          c2_v_b[c2_i9] = c2_gb_x[c2_i9];
        }

        c2_b_eml_scalar_eg(chartInstance);
        c2_b_eml_scalar_eg(chartInstance);
        c2_tau = 0.0;
        for (c2_k = 1; c2_k < 5; c2_k++) {
          c2_b_k = c2_k;
          c2_tau += c2_dv3[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c2_b_k), 1, 4, 1, 0) - 1] *
            c2_v_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
            "", (real_T)c2_b_k), 1, 4, 1, 0) - 1];
        }

        _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 63);
        c2_state = 2.0;
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 68);
    c2_u0 = 0.0;
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 69);
    c2_w_b = c2_x[1];
    c2_v_y = -700.0 * c2_w_b;
    c2_x_b = c2_x[3];
    c2_w_y = 24.330329056549974 * c2_x_b;
    c2_u = (c2_v_y - c2_w_y) + c2_u0;
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 70);
    c2_h_a = c2_J_tot;
    c2_y_b = c2_u;
    c2_x_y = c2_h_a * c2_y_b;
    c2_A = (c2_x_y - c2_T_pc) - c2_T_pg;
    c2_B = c2_T_ptau;
    c2_hb_x = c2_A;
    c2_y_y = c2_B;
    c2_ib_x = c2_hb_x;
    c2_ab_y = c2_y_y;
    c2_tau = c2_ib_x / c2_ab_y;
    _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, 71);
    c2_state = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c2_sfEvent, -71);
  _SFD_SYMBOL_SCOPE_POP();
  *c2_b_tau = c2_tau;
  *c2_b_u = c2_u;
  *c2_b_u0 = c2_u0;
  *c2_b_E_c = c2_E_c;
  *c2_b_E = c2_E;
  *c2_b_state = c2_state;
  *c2_d_LQR_control = c2_LQR_control;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c2_sfEvent);
}

static void initSimStructsc2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static void registerMessagesc2_FeedbackLinearization_StateSpace
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static void c2_hysteresis(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance, real_T c2_x[6], real_T c2_limit[4], boolean_T c2_LQR_state,
  real_T c2_x_lim[2], real_T *c2_LQR_control)
{
  uint32_T c2_debug_family_var_map[11];
  real_T c2_x1_max_lim;
  real_T c2_x2_max_lim;
  real_T c2_x1_LQR_lim;
  real_T c2_x2_LQR_lim;
  real_T c2_nargin = 3.0;
  real_T c2_nargout = 2.0;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_y;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_b_y;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_c_y;
  real_T c2_h_x;
  real_T c2_i_x;
  real_T c2_d_y;
  real_T c2_j_x;
  real_T c2_k_x;
  real_T c2_e_y;
  real_T c2_l_x;
  real_T c2_m_x;
  real_T c2_f_y;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c2_b_debug_family_names,
    c2_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x1_max_lim, 0U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x2_max_lim, 1U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x1_LQR_lim, 2U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x2_LQR_lim, 3U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargin, 4U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargout, 5U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x, 6U, c2_f_sf_marshallOut,
    c2_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_limit, 7U, c2_d_sf_marshallOut,
    c2_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_LQR_state, 8U, c2_e_sf_marshallOut,
    c2_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x_lim, 9U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_LQR_control, 10U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 24);
  c2_x1_max_lim = c2_limit[0];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 25);
  c2_x2_max_lim = c2_limit[1];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 26);
  c2_x1_LQR_lim = c2_limit[2];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 27);
  c2_x2_LQR_lim = c2_limit[3];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 29);
  c2_b_x = c2_x[0];
  c2_c_x = c2_b_x;
  c2_y = muDoubleScalarAbs(c2_c_x);
  guard1 = FALSE;
  if (CV_SCRIPT_COND(0, 0, c2_mod(chartInstance, c2_y, 6.2831853071795862) <=
                     c2_x1_LQR_lim)) {
    c2_d_x = c2_x[1];
    c2_e_x = c2_d_x;
    c2_b_y = muDoubleScalarAbs(c2_e_x);
    if (CV_SCRIPT_COND(0, 1, c2_mod(chartInstance, c2_b_y, 6.2831853071795862) <=
                       c2_x2_LQR_lim)) {
      CV_SCRIPT_MCDC(0, 0, TRUE);
      CV_SCRIPT_IF(0, 0, TRUE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 30);
      c2_x_lim[0] = c2_x1_max_lim;
      c2_x_lim[1] = c2_x2_max_lim;
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 31);
      *c2_LQR_control = 1.0;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_SCRIPT_MCDC(0, 0, FALSE);
    CV_SCRIPT_IF(0, 0, FALSE);
    _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 32);
    c2_f_x = c2_x[0];
    c2_g_x = c2_f_x;
    c2_c_y = muDoubleScalarAbs(c2_g_x);
    guard2 = FALSE;
    guard3 = FALSE;
    if (CV_SCRIPT_COND(0, 2, c2_mod(chartInstance, c2_c_y, 6.2831853071795862) <=
                       c2_x1_max_lim)) {
      c2_h_x = c2_x[1];
      c2_i_x = c2_h_x;
      c2_d_y = muDoubleScalarAbs(c2_i_x);
      if (CV_SCRIPT_COND(0, 3, c2_mod(chartInstance, c2_d_y, 6.2831853071795862)
                         <= c2_x2_max_lim)) {
        if (CV_SCRIPT_COND(0, 4, c2_LQR_state)) {
          CV_SCRIPT_MCDC(0, 1, TRUE);
          CV_SCRIPT_IF(0, 1, TRUE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 33);
          c2_x_lim[0] = c2_x1_max_lim;
          c2_x_lim[1] = c2_x2_max_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 34);
          *c2_LQR_control = 1.0;
        } else {
          guard2 = TRUE;
        }
      } else {
        guard3 = TRUE;
      }
    } else {
      guard3 = TRUE;
    }

    if (guard3 == TRUE) {
      guard2 = TRUE;
    }

    if (guard2 == TRUE) {
      CV_SCRIPT_MCDC(0, 1, FALSE);
      CV_SCRIPT_IF(0, 1, FALSE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 35);
      c2_j_x = c2_x[0];
      c2_k_x = c2_j_x;
      c2_e_y = muDoubleScalarAbs(c2_k_x);
      guard4 = FALSE;
      if (CV_SCRIPT_COND(0, 5, c2_mod(chartInstance, c2_e_y, 6.2831853071795862)
                         > c2_x1_max_lim)) {
        guard4 = TRUE;
      } else {
        c2_l_x = c2_x[1];
        c2_m_x = c2_l_x;
        c2_f_y = muDoubleScalarAbs(c2_m_x);
        if (CV_SCRIPT_COND(0, 6, c2_mod(chartInstance, c2_f_y,
              6.2831853071795862) > c2_x2_max_lim)) {
          guard4 = TRUE;
        } else {
          CV_SCRIPT_MCDC(0, 2, FALSE);
          CV_SCRIPT_IF(0, 2, FALSE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 39);
          c2_x_lim[0] = c2_x1_LQR_lim;
          c2_x_lim[1] = c2_x2_LQR_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 40);
          *c2_LQR_control = 0.0;
        }
      }

      if (guard4 == TRUE) {
        CV_SCRIPT_MCDC(0, 2, TRUE);
        CV_SCRIPT_IF(0, 2, TRUE);
        _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 36);
        c2_x_lim[0] = c2_x1_LQR_lim;
        c2_x_lim[1] = c2_x2_LQR_lim;
        _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 37);
        *c2_LQR_control = 0.0;
      }
    }
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, -40);
  _SFD_SYMBOL_SCOPE_POP();
}

static void c2_b_hysteresis(SFc2_FeedbackLinearization_StateSpaceInstanceStruct *
  chartInstance, real_T c2_x[6], real_T c2_limit[4], real_T c2_LQR_state, real_T
  c2_x_lim[2], real_T *c2_LQR_control)
{
  uint32_T c2_debug_family_var_map[11];
  real_T c2_x1_max_lim;
  real_T c2_x2_max_lim;
  real_T c2_x1_LQR_lim;
  real_T c2_x2_LQR_lim;
  real_T c2_nargin = 3.0;
  real_T c2_nargout = 2.0;
  real_T c2_b_x;
  real_T c2_c_x;
  real_T c2_y;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_b_y;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_c_y;
  real_T c2_h_x;
  real_T c2_i_x;
  real_T c2_d_y;
  real_T c2_j_x;
  real_T c2_k_x;
  real_T c2_e_y;
  real_T c2_l_x;
  real_T c2_m_x;
  real_T c2_f_y;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c2_c_debug_family_names,
    c2_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x1_max_lim, 0U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x2_max_lim, 1U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x1_LQR_lim, 2U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_x2_LQR_lim, 3U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargin, 4U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_nargout, 5U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x, 6U, c2_f_sf_marshallOut,
    c2_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_limit, 7U, c2_d_sf_marshallOut,
    c2_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c2_LQR_state, 8U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_x_lim, 9U, c2_c_sf_marshallOut,
    c2_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c2_LQR_control, 10U, c2_sf_marshallOut,
    c2_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 24);
  c2_x1_max_lim = c2_limit[0];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 25);
  c2_x2_max_lim = c2_limit[1];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 26);
  c2_x1_LQR_lim = c2_limit[2];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 27);
  c2_x2_LQR_lim = c2_limit[3];
  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 29);
  c2_b_x = c2_x[0];
  c2_c_x = c2_b_x;
  c2_y = muDoubleScalarAbs(c2_c_x);
  guard1 = FALSE;
  if (CV_SCRIPT_COND(0, 0, c2_mod(chartInstance, c2_y, 6.2831853071795862) <=
                     c2_x1_LQR_lim)) {
    c2_d_x = c2_x[1];
    c2_e_x = c2_d_x;
    c2_b_y = muDoubleScalarAbs(c2_e_x);
    if (CV_SCRIPT_COND(0, 1, c2_mod(chartInstance, c2_b_y, 6.2831853071795862) <=
                       c2_x2_LQR_lim)) {
      CV_SCRIPT_MCDC(0, 0, TRUE);
      CV_SCRIPT_IF(0, 0, TRUE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 30);
      c2_x_lim[0] = c2_x1_max_lim;
      c2_x_lim[1] = c2_x2_max_lim;
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 31);
      *c2_LQR_control = 1.0;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_SCRIPT_MCDC(0, 0, FALSE);
    CV_SCRIPT_IF(0, 0, FALSE);
    _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 32);
    c2_f_x = c2_x[0];
    c2_g_x = c2_f_x;
    c2_c_y = muDoubleScalarAbs(c2_g_x);
    guard2 = FALSE;
    guard3 = FALSE;
    if (CV_SCRIPT_COND(0, 2, c2_mod(chartInstance, c2_c_y, 6.2831853071795862) <=
                       c2_x1_max_lim)) {
      c2_h_x = c2_x[1];
      c2_i_x = c2_h_x;
      c2_d_y = muDoubleScalarAbs(c2_i_x);
      if (CV_SCRIPT_COND(0, 3, c2_mod(chartInstance, c2_d_y, 6.2831853071795862)
                         <= c2_x2_max_lim)) {
        if (CV_SCRIPT_COND(0, 4, c2_LQR_state == 1.0)) {
          CV_SCRIPT_MCDC(0, 1, TRUE);
          CV_SCRIPT_IF(0, 1, TRUE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 33);
          c2_x_lim[0] = c2_x1_max_lim;
          c2_x_lim[1] = c2_x2_max_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 34);
          *c2_LQR_control = 1.0;
        } else {
          guard2 = TRUE;
        }
      } else {
        guard3 = TRUE;
      }
    } else {
      guard3 = TRUE;
    }

    if (guard3 == TRUE) {
      guard2 = TRUE;
    }

    if (guard2 == TRUE) {
      CV_SCRIPT_MCDC(0, 1, FALSE);
      CV_SCRIPT_IF(0, 1, FALSE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 35);
      c2_j_x = c2_x[0];
      c2_k_x = c2_j_x;
      c2_e_y = muDoubleScalarAbs(c2_k_x);
      guard4 = FALSE;
      if (CV_SCRIPT_COND(0, 5, c2_mod(chartInstance, c2_e_y, 6.2831853071795862)
                         > c2_x1_max_lim)) {
        guard4 = TRUE;
      } else {
        c2_l_x = c2_x[1];
        c2_m_x = c2_l_x;
        c2_f_y = muDoubleScalarAbs(c2_m_x);
        if (CV_SCRIPT_COND(0, 6, c2_mod(chartInstance, c2_f_y,
              6.2831853071795862) > c2_x2_max_lim)) {
          guard4 = TRUE;
        } else {
          CV_SCRIPT_MCDC(0, 2, FALSE);
          CV_SCRIPT_IF(0, 2, FALSE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 39);
          c2_x_lim[0] = c2_x1_LQR_lim;
          c2_x_lim[1] = c2_x2_LQR_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 40);
          *c2_LQR_control = 0.0;
        }
      }

      if (guard4 == TRUE) {
        CV_SCRIPT_MCDC(0, 2, TRUE);
        CV_SCRIPT_IF(0, 2, TRUE);
        _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 36);
        c2_x_lim[0] = c2_x1_LQR_lim;
        c2_x_lim[1] = c2_x2_LQR_lim;
        _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, 37);
        *c2_LQR_control = 0.0;
      }
    }
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c2_sfEvent, -40);
  _SFD_SYMBOL_SCOPE_POP();
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c2_chartNumber, 0U, sf_debug_get_script_id(
    "C:/Users/jorgni/Documents/Masteroppgave/Matlab/Partially Feedback Linearized Controllers/hysteresis.m"));
}

static const mxArray *c2_sf_marshallOut(void *chartInstanceVoid, void *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  real_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(real_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static real_T c2_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_LQR_control, const char_T *c2_identifier)
{
  real_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_LQR_control),
    &c2_thisId);
  sf_mex_destroy(&c2_LQR_control);
  return c2_y;
}

static real_T c2_b_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  real_T c2_y;
  real_T c2_d0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_y = c2_d0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_LQR_control;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_LQR_control = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_LQR_control),
    &c2_thisId);
  sf_mex_destroy(&c2_LQR_control);
  *(real_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_b_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i10;
  real_T c2_b_inData[6];
  int32_T c2_i11;
  real_T c2_u[6];
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i10 = 0; c2_i10 < 6; c2_i10++) {
    c2_b_inData[c2_i10] = (*(real_T (*)[6])c2_inData)[c2_i10];
  }

  for (c2_i11 = 0; c2_i11 < 6; c2_i11++) {
    c2_u[c2_i11] = c2_b_inData[c2_i11];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 6, 1), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static const mxArray *c2_c_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i12;
  real_T c2_b_inData[2];
  int32_T c2_i13;
  real_T c2_u[2];
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i12 = 0; c2_i12 < 2; c2_i12++) {
    c2_b_inData[c2_i12] = (*(real_T (*)[2])c2_inData)[c2_i12];
  }

  for (c2_i13 = 0; c2_i13 < 2; c2_i13++) {
    c2_u[c2_i13] = c2_b_inData[c2_i13];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_c_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[2])
{
  real_T c2_dv4[2];
  int32_T c2_i14;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv4, 1, 0, 0U, 1, 0U, 2, 1, 2);
  for (c2_i14 = 0; c2_i14 < 2; c2_i14++) {
    c2_y[c2_i14] = c2_dv4[c2_i14];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_x_lim;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[2];
  int32_T c2_i15;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_x_lim = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_x_lim), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_x_lim);
  for (c2_i15 = 0; c2_i15 < 2; c2_i15++) {
    (*(real_T (*)[2])c2_outData)[c2_i15] = c2_y[c2_i15];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_d_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i16;
  real_T c2_b_inData[4];
  int32_T c2_i17;
  real_T c2_u[4];
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i16 = 0; c2_i16 < 4; c2_i16++) {
    c2_b_inData[c2_i16] = (*(real_T (*)[4])c2_inData)[c2_i16];
  }

  for (c2_i17 = 0; c2_i17 < 4; c2_i17++) {
    c2_u[c2_i17] = c2_b_inData[c2_i17];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 2, 1, 4), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static const mxArray *c2_e_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  boolean_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(boolean_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 11, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static boolean_T c2_d_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  boolean_T c2_y;
  boolean_T c2_b0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_b0, 1, 11, 0U, 0, 0U, 0);
  c2_y = c2_b0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_LQR_state;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  boolean_T c2_y;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_LQR_state = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_LQR_state),
    &c2_thisId);
  sf_mex_destroy(&c2_LQR_state);
  *(boolean_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static void c2_e_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[4])
{
  real_T c2_dv5[4];
  int32_T c2_i18;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv5, 1, 0, 0U, 1, 0U, 2, 1, 4);
  for (c2_i18 = 0; c2_i18 < 4; c2_i18++) {
    c2_y[c2_i18] = c2_dv5[c2_i18];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_limit;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[4];
  int32_T c2_i19;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_limit = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_limit), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_limit);
  for (c2_i19 = 0; c2_i19 < 4; c2_i19++) {
    (*(real_T (*)[4])c2_outData)[c2_i19] = c2_y[c2_i19];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

static const mxArray *c2_f_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_i20;
  real_T c2_b_inData[6];
  int32_T c2_i21;
  real_T c2_u[6];
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  for (c2_i20 = 0; c2_i20 < 6; c2_i20++) {
    c2_b_inData[c2_i20] = (*(real_T (*)[6])c2_inData)[c2_i20];
  }

  for (c2_i21 = 0; c2_i21 < 6; c2_i21++) {
    c2_u[c2_i21] = c2_b_inData[c2_i21];
  }

  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", c2_u, 0, 0U, 1U, 0U, 1, 6), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static void c2_f_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId, real_T c2_y[6])
{
  real_T c2_dv6[6];
  int32_T c2_i22;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), c2_dv6, 1, 0, 0U, 1, 0U, 1, 6);
  for (c2_i22 = 0; c2_i22 < 6; c2_i22++) {
    c2_y[c2_i22] = c2_dv6[c2_i22];
  }

  sf_mex_destroy(&c2_u);
}

static void c2_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_x;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  real_T c2_y[6];
  int32_T c2_i23;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_x = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_x), &c2_thisId, c2_y);
  sf_mex_destroy(&c2_x);
  for (c2_i23 = 0; c2_i23 < 6; c2_i23++) {
    (*(real_T (*)[6])c2_outData)[c2_i23] = c2_y[c2_i23];
  }

  sf_mex_destroy(&c2_mxArrayInData);
}

const mxArray
  *sf_c2_FeedbackLinearization_StateSpace_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo;
  c2_ResolvedFunctionInfo c2_info[57];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i24;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_nameCaptureInfo = NULL;
  c2_info_helper(c2_info);
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 57), FALSE);
  for (c2_i24 = 0; c2_i24 < 57; c2_i24++) {
    c2_r0 = &c2_info[c2_i24];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context", "nameCaptureInfo",
                    c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name", "nameCaptureInfo", c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved", "nameCaptureInfo",
                    c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c2_i24);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c2_i24);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c2_nameCaptureInfo);
  return c2_nameCaptureInfo;
}

static void c2_info_helper(c2_ResolvedFunctionInfo c2_info[57])
{
  c2_info[0].context = "";
  c2_info[0].name = "mpower";
  c2_info[0].dominantType = "double";
  c2_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c2_info[0].fileTimeLo = 1286818842U;
  c2_info[0].fileTimeHi = 0U;
  c2_info[0].mFileTimeLo = 0U;
  c2_info[0].mFileTimeHi = 0U;
  c2_info[1].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c2_info[1].name = "power";
  c2_info[1].dominantType = "double";
  c2_info[1].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c2_info[1].fileTimeLo = 1348191930U;
  c2_info[1].fileTimeHi = 0U;
  c2_info[1].mFileTimeLo = 0U;
  c2_info[1].mFileTimeHi = 0U;
  c2_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c2_info[2].name = "eml_scalar_eg";
  c2_info[2].dominantType = "double";
  c2_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[2].fileTimeLo = 1286818796U;
  c2_info[2].fileTimeHi = 0U;
  c2_info[2].mFileTimeLo = 0U;
  c2_info[2].mFileTimeHi = 0U;
  c2_info[3].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c2_info[3].name = "eml_scalexp_alloc";
  c2_info[3].dominantType = "double";
  c2_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c2_info[3].fileTimeLo = 1352424860U;
  c2_info[3].fileTimeHi = 0U;
  c2_info[3].mFileTimeLo = 0U;
  c2_info[3].mFileTimeHi = 0U;
  c2_info[4].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c2_info[4].name = "floor";
  c2_info[4].dominantType = "double";
  c2_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c2_info[4].fileTimeLo = 1343830380U;
  c2_info[4].fileTimeHi = 0U;
  c2_info[4].mFileTimeLo = 0U;
  c2_info[4].mFileTimeHi = 0U;
  c2_info[5].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c2_info[5].name = "eml_scalar_floor";
  c2_info[5].dominantType = "double";
  c2_info[5].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c2_info[5].fileTimeLo = 1286818726U;
  c2_info[5].fileTimeHi = 0U;
  c2_info[5].mFileTimeLo = 0U;
  c2_info[5].mFileTimeHi = 0U;
  c2_info[6].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c2_info[6].name = "eml_scalar_eg";
  c2_info[6].dominantType = "double";
  c2_info[6].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[6].fileTimeLo = 1286818796U;
  c2_info[6].fileTimeHi = 0U;
  c2_info[6].mFileTimeLo = 0U;
  c2_info[6].mFileTimeHi = 0U;
  c2_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c2_info[7].name = "mtimes";
  c2_info[7].dominantType = "double";
  c2_info[7].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[7].fileTimeLo = 1289519692U;
  c2_info[7].fileTimeHi = 0U;
  c2_info[7].mFileTimeLo = 0U;
  c2_info[7].mFileTimeHi = 0U;
  c2_info[8].context = "";
  c2_info[8].name = "mtimes";
  c2_info[8].dominantType = "double";
  c2_info[8].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[8].fileTimeLo = 1289519692U;
  c2_info[8].fileTimeHi = 0U;
  c2_info[8].mFileTimeLo = 0U;
  c2_info[8].mFileTimeHi = 0U;
  c2_info[9].context = "";
  c2_info[9].name = "cos";
  c2_info[9].dominantType = "double";
  c2_info[9].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[9].fileTimeLo = 1343830372U;
  c2_info[9].fileTimeHi = 0U;
  c2_info[9].mFileTimeLo = 0U;
  c2_info[9].mFileTimeHi = 0U;
  c2_info[10].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c2_info[10].name = "eml_scalar_cos";
  c2_info[10].dominantType = "double";
  c2_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c2_info[10].fileTimeLo = 1286818722U;
  c2_info[10].fileTimeHi = 0U;
  c2_info[10].mFileTimeLo = 0U;
  c2_info[10].mFileTimeHi = 0U;
  c2_info[11].context = "";
  c2_info[11].name = "mrdivide";
  c2_info[11].dominantType = "double";
  c2_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[11].fileTimeLo = 1357951548U;
  c2_info[11].fileTimeHi = 0U;
  c2_info[11].mFileTimeLo = 1319729966U;
  c2_info[11].mFileTimeHi = 0U;
  c2_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c2_info[12].name = "rdivide";
  c2_info[12].dominantType = "double";
  c2_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[12].fileTimeLo = 1346510388U;
  c2_info[12].fileTimeHi = 0U;
  c2_info[12].mFileTimeLo = 0U;
  c2_info[12].mFileTimeHi = 0U;
  c2_info[13].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[13].name = "eml_scalexp_compatible";
  c2_info[13].dominantType = "double";
  c2_info[13].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c2_info[13].fileTimeLo = 1286818796U;
  c2_info[13].fileTimeHi = 0U;
  c2_info[13].mFileTimeLo = 0U;
  c2_info[13].mFileTimeHi = 0U;
  c2_info[14].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c2_info[14].name = "eml_div";
  c2_info[14].dominantType = "double";
  c2_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c2_info[14].fileTimeLo = 1313347810U;
  c2_info[14].fileTimeHi = 0U;
  c2_info[14].mFileTimeLo = 0U;
  c2_info[14].mFileTimeHi = 0U;
  c2_info[15].context = "";
  c2_info[15].name = "sin";
  c2_info[15].dominantType = "double";
  c2_info[15].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[15].fileTimeLo = 1343830386U;
  c2_info[15].fileTimeHi = 0U;
  c2_info[15].mFileTimeLo = 0U;
  c2_info[15].mFileTimeHi = 0U;
  c2_info[16].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sin.m";
  c2_info[16].name = "eml_scalar_sin";
  c2_info[16].dominantType = "double";
  c2_info[16].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sin.m";
  c2_info[16].fileTimeLo = 1286818736U;
  c2_info[16].fileTimeHi = 0U;
  c2_info[16].mFileTimeLo = 0U;
  c2_info[16].mFileTimeHi = 0U;
  c2_info[17].context = "";
  c2_info[17].name = "sqrt";
  c2_info[17].dominantType = "double";
  c2_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c2_info[17].fileTimeLo = 1343830386U;
  c2_info[17].fileTimeHi = 0U;
  c2_info[17].mFileTimeLo = 0U;
  c2_info[17].mFileTimeHi = 0U;
  c2_info[18].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c2_info[18].name = "eml_error";
  c2_info[18].dominantType = "char";
  c2_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_error.m";
  c2_info[18].fileTimeLo = 1343830358U;
  c2_info[18].fileTimeHi = 0U;
  c2_info[18].mFileTimeLo = 0U;
  c2_info[18].mFileTimeHi = 0U;
  c2_info[19].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/sqrt.m";
  c2_info[19].name = "eml_scalar_sqrt";
  c2_info[19].dominantType = "double";
  c2_info[19].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_sqrt.m";
  c2_info[19].fileTimeLo = 1286818738U;
  c2_info[19].fileTimeHi = 0U;
  c2_info[19].mFileTimeLo = 0U;
  c2_info[19].mFileTimeHi = 0U;
  c2_info[20].context = "";
  c2_info[20].name = "hysteresis";
  c2_info[20].dominantType = "double";
  c2_info[20].resolved =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Partially Feedback Linearized Controllers/hysteresis.m";
  c2_info[20].fileTimeLo = 1398243731U;
  c2_info[20].fileTimeHi = 0U;
  c2_info[20].mFileTimeLo = 0U;
  c2_info[20].mFileTimeHi = 0U;
  c2_info[21].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Partially Feedback Linearized Controllers/hysteresis.m";
  c2_info[21].name = "abs";
  c2_info[21].dominantType = "double";
  c2_info[21].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[21].fileTimeLo = 1343830366U;
  c2_info[21].fileTimeHi = 0U;
  c2_info[21].mFileTimeLo = 0U;
  c2_info[21].mFileTimeHi = 0U;
  c2_info[22].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[22].name = "eml_scalar_abs";
  c2_info[22].dominantType = "double";
  c2_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c2_info[22].fileTimeLo = 1286818712U;
  c2_info[22].fileTimeHi = 0U;
  c2_info[22].mFileTimeLo = 0U;
  c2_info[22].mFileTimeHi = 0U;
  c2_info[23].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Partially Feedback Linearized Controllers/hysteresis.m";
  c2_info[23].name = "mtimes";
  c2_info[23].dominantType = "double";
  c2_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[23].fileTimeLo = 1289519692U;
  c2_info[23].fileTimeHi = 0U;
  c2_info[23].mFileTimeLo = 0U;
  c2_info[23].mFileTimeHi = 0U;
  c2_info[24].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Partially Feedback Linearized Controllers/hysteresis.m";
  c2_info[24].name = "mod";
  c2_info[24].dominantType = "double";
  c2_info[24].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c2_info[24].fileTimeLo = 1343830382U;
  c2_info[24].fileTimeHi = 0U;
  c2_info[24].mFileTimeLo = 0U;
  c2_info[24].mFileTimeHi = 0U;
  c2_info[25].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c2_info[25].name = "eml_scalar_eg";
  c2_info[25].dominantType = "double";
  c2_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[25].fileTimeLo = 1286818796U;
  c2_info[25].fileTimeHi = 0U;
  c2_info[25].mFileTimeLo = 0U;
  c2_info[25].mFileTimeHi = 0U;
  c2_info[26].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c2_info[26].name = "eml_scalexp_alloc";
  c2_info[26].dominantType = "double";
  c2_info[26].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c2_info[26].fileTimeLo = 1352424860U;
  c2_info[26].fileTimeHi = 0U;
  c2_info[26].mFileTimeLo = 0U;
  c2_info[26].mFileTimeHi = 0U;
  c2_info[27].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[27].name = "eml_scalar_eg";
  c2_info[27].dominantType = "double";
  c2_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[27].fileTimeLo = 1286818796U;
  c2_info[27].fileTimeHi = 0U;
  c2_info[27].mFileTimeLo = 0U;
  c2_info[27].mFileTimeHi = 0U;
  c2_info[28].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[28].name = "eml_scalar_floor";
  c2_info[28].dominantType = "double";
  c2_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c2_info[28].fileTimeLo = 1286818726U;
  c2_info[28].fileTimeHi = 0U;
  c2_info[28].mFileTimeLo = 0U;
  c2_info[28].mFileTimeHi = 0U;
  c2_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[29].name = "eml_scalar_round";
  c2_info[29].dominantType = "double";
  c2_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_round.m";
  c2_info[29].fileTimeLo = 1307651238U;
  c2_info[29].fileTimeHi = 0U;
  c2_info[29].mFileTimeLo = 0U;
  c2_info[29].mFileTimeHi = 0U;
  c2_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[30].name = "eml_scalar_abs";
  c2_info[30].dominantType = "double";
  c2_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c2_info[30].fileTimeLo = 1286818712U;
  c2_info[30].fileTimeHi = 0U;
  c2_info[30].mFileTimeLo = 0U;
  c2_info[30].mFileTimeHi = 0U;
  c2_info[31].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[31].name = "eps";
  c2_info[31].dominantType = "char";
  c2_info[31].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[31].fileTimeLo = 1326727996U;
  c2_info[31].fileTimeHi = 0U;
  c2_info[31].mFileTimeLo = 0U;
  c2_info[31].mFileTimeHi = 0U;
  c2_info[32].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[32].name = "eml_is_float_class";
  c2_info[32].dominantType = "char";
  c2_info[32].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c2_info[32].fileTimeLo = 1286818782U;
  c2_info[32].fileTimeHi = 0U;
  c2_info[32].mFileTimeLo = 0U;
  c2_info[32].mFileTimeHi = 0U;
  c2_info[33].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c2_info[33].name = "eml_eps";
  c2_info[33].dominantType = "char";
  c2_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c2_info[33].fileTimeLo = 1326727996U;
  c2_info[33].fileTimeHi = 0U;
  c2_info[33].mFileTimeLo = 0U;
  c2_info[33].mFileTimeHi = 0U;
  c2_info[34].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c2_info[34].name = "eml_float_model";
  c2_info[34].dominantType = "char";
  c2_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c2_info[34].fileTimeLo = 1326727996U;
  c2_info[34].fileTimeHi = 0U;
  c2_info[34].mFileTimeLo = 0U;
  c2_info[34].mFileTimeHi = 0U;
  c2_info[35].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c2_info[35].name = "mtimes";
  c2_info[35].dominantType = "double";
  c2_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[35].fileTimeLo = 1289519692U;
  c2_info[35].fileTimeHi = 0U;
  c2_info[35].mFileTimeLo = 0U;
  c2_info[35].mFileTimeHi = 0U;
  c2_info[36].context = "";
  c2_info[36].name = "abs";
  c2_info[36].dominantType = "double";
  c2_info[36].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c2_info[36].fileTimeLo = 1343830366U;
  c2_info[36].fileTimeHi = 0U;
  c2_info[36].mFileTimeLo = 0U;
  c2_info[36].mFileTimeHi = 0U;
  c2_info[37].context = "";
  c2_info[37].name = "mod";
  c2_info[37].dominantType = "double";
  c2_info[37].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c2_info[37].fileTimeLo = 1343830382U;
  c2_info[37].fileTimeHi = 0U;
  c2_info[37].mFileTimeLo = 0U;
  c2_info[37].mFileTimeHi = 0U;
  c2_info[38].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[38].name = "eml_index_class";
  c2_info[38].dominantType = "";
  c2_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[38].fileTimeLo = 1323170578U;
  c2_info[38].fileTimeHi = 0U;
  c2_info[38].mFileTimeLo = 0U;
  c2_info[38].mFileTimeHi = 0U;
  c2_info[39].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[39].name = "eml_scalar_eg";
  c2_info[39].dominantType = "double";
  c2_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[39].fileTimeLo = 1286818796U;
  c2_info[39].fileTimeHi = 0U;
  c2_info[39].mFileTimeLo = 0U;
  c2_info[39].mFileTimeHi = 0U;
  c2_info[40].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c2_info[40].name = "eml_xdotu";
  c2_info[40].dominantType = "double";
  c2_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c2_info[40].fileTimeLo = 1299076772U;
  c2_info[40].fileTimeHi = 0U;
  c2_info[40].mFileTimeLo = 0U;
  c2_info[40].mFileTimeHi = 0U;
  c2_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c2_info[41].name = "eml_blas_inline";
  c2_info[41].dominantType = "";
  c2_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c2_info[41].fileTimeLo = 1299076768U;
  c2_info[41].fileTimeHi = 0U;
  c2_info[41].mFileTimeLo = 0U;
  c2_info[41].mFileTimeHi = 0U;
  c2_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c2_info[42].name = "eml_xdot";
  c2_info[42].dominantType = "double";
  c2_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c2_info[42].fileTimeLo = 1299076772U;
  c2_info[42].fileTimeHi = 0U;
  c2_info[42].mFileTimeLo = 0U;
  c2_info[42].mFileTimeHi = 0U;
  c2_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c2_info[43].name = "eml_blas_inline";
  c2_info[43].dominantType = "";
  c2_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c2_info[43].fileTimeLo = 1299076768U;
  c2_info[43].fileTimeHi = 0U;
  c2_info[43].mFileTimeLo = 0U;
  c2_info[43].mFileTimeHi = 0U;
  c2_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c2_info[44].name = "eml_index_class";
  c2_info[44].dominantType = "";
  c2_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[44].fileTimeLo = 1323170578U;
  c2_info[44].fileTimeHi = 0U;
  c2_info[44].mFileTimeLo = 0U;
  c2_info[44].mFileTimeHi = 0U;
  c2_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c2_info[45].name = "eml_refblas_xdot";
  c2_info[45].dominantType = "double";
  c2_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c2_info[45].fileTimeLo = 1299076772U;
  c2_info[45].fileTimeHi = 0U;
  c2_info[45].mFileTimeLo = 0U;
  c2_info[45].mFileTimeHi = 0U;
  c2_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c2_info[46].name = "eml_refblas_xdotx";
  c2_info[46].dominantType = "char";
  c2_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[46].fileTimeLo = 1299076774U;
  c2_info[46].fileTimeHi = 0U;
  c2_info[46].mFileTimeLo = 0U;
  c2_info[46].mFileTimeHi = 0U;
  c2_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[47].name = "eml_scalar_eg";
  c2_info[47].dominantType = "double";
  c2_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c2_info[47].fileTimeLo = 1286818796U;
  c2_info[47].fileTimeHi = 0U;
  c2_info[47].mFileTimeLo = 0U;
  c2_info[47].mFileTimeHi = 0U;
  c2_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[48].name = "eml_index_class";
  c2_info[48].dominantType = "";
  c2_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[48].fileTimeLo = 1323170578U;
  c2_info[48].fileTimeHi = 0U;
  c2_info[48].mFileTimeLo = 0U;
  c2_info[48].mFileTimeHi = 0U;
  c2_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[49].name = "eml_index_minus";
  c2_info[49].dominantType = "double";
  c2_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c2_info[49].fileTimeLo = 1286818778U;
  c2_info[49].fileTimeHi = 0U;
  c2_info[49].mFileTimeLo = 0U;
  c2_info[49].mFileTimeHi = 0U;
  c2_info[50].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c2_info[50].name = "eml_index_class";
  c2_info[50].dominantType = "";
  c2_info[50].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[50].fileTimeLo = 1323170578U;
  c2_info[50].fileTimeHi = 0U;
  c2_info[50].mFileTimeLo = 0U;
  c2_info[50].mFileTimeHi = 0U;
  c2_info[51].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[51].name = "eml_index_times";
  c2_info[51].dominantType = "coder.internal.indexInt";
  c2_info[51].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c2_info[51].fileTimeLo = 1286818780U;
  c2_info[51].fileTimeHi = 0U;
  c2_info[51].mFileTimeLo = 0U;
  c2_info[51].mFileTimeHi = 0U;
  c2_info[52].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c2_info[52].name = "eml_index_class";
  c2_info[52].dominantType = "";
  c2_info[52].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[52].fileTimeLo = 1323170578U;
  c2_info[52].fileTimeHi = 0U;
  c2_info[52].mFileTimeLo = 0U;
  c2_info[52].mFileTimeHi = 0U;
  c2_info[53].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[53].name = "eml_index_plus";
  c2_info[53].dominantType = "coder.internal.indexInt";
  c2_info[53].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c2_info[53].fileTimeLo = 1286818778U;
  c2_info[53].fileTimeHi = 0U;
  c2_info[53].mFileTimeLo = 0U;
  c2_info[53].mFileTimeHi = 0U;
  c2_info[54].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c2_info[54].name = "eml_index_class";
  c2_info[54].dominantType = "";
  c2_info[54].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c2_info[54].fileTimeLo = 1323170578U;
  c2_info[54].fileTimeHi = 0U;
  c2_info[54].mFileTimeLo = 0U;
  c2_info[54].mFileTimeHi = 0U;
  c2_info[55].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c2_info[55].name = "eml_int_forloop_overflow_check";
  c2_info[55].dominantType = "";
  c2_info[55].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c2_info[55].fileTimeLo = 1346510340U;
  c2_info[55].fileTimeHi = 0U;
  c2_info[55].mFileTimeLo = 0U;
  c2_info[55].mFileTimeHi = 0U;
  c2_info[56].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c2_info[56].name = "intmax";
  c2_info[56].dominantType = "char";
  c2_info[56].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c2_info[56].fileTimeLo = 1311255316U;
  c2_info[56].fileTimeHi = 0U;
  c2_info[56].mFileTimeLo = 0U;
  c2_info[56].mFileTimeHi = 0U;
}

static real_T c2_mpower(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance, real_T c2_a)
{
  real_T c2_b_a;
  real_T c2_c_a;
  real_T c2_ak;
  real_T c2_d_a;
  real_T c2_e_a;
  real_T c2_b;
  c2_b_a = c2_a;
  c2_c_a = c2_b_a;
  c2_eml_scalar_eg(chartInstance);
  c2_ak = c2_c_a;
  c2_d_a = c2_ak;
  c2_eml_scalar_eg(chartInstance);
  c2_e_a = c2_d_a;
  c2_b = c2_d_a;
  return c2_e_a * c2_b;
}

static void c2_eml_scalar_eg(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
  *chartInstance)
{
}

static real_T c2_mod(SFc2_FeedbackLinearization_StateSpaceInstanceStruct
                     *chartInstance, real_T c2_x, real_T c2_y)
{
  real_T c2_r;
  real_T c2_xk;
  real_T c2_yk;
  real_T c2_b_x;
  real_T c2_b_y;
  real_T c2_c_x;
  real_T c2_d_x;
  real_T c2_e_x;
  real_T c2_f_x;
  real_T c2_g_x;
  real_T c2_h_x;
  real_T c2_i_x;
  real_T c2_c_y;
  real_T c2_j_x;
  real_T c2_d_y;
  real_T c2_b;
  real_T c2_e_y;
  real_T c2_k_x;
  real_T c2_l_x;
  c2_eml_scalar_eg(chartInstance);
  c2_xk = c2_x;
  c2_yk = c2_y;
  c2_b_x = c2_xk;
  c2_b_y = c2_yk;
  c2_eml_scalar_eg(chartInstance);
  if (c2_b_y == 0.0) {
    c2_r = c2_b_x;
  } else {
    c2_c_x = c2_b_y;
    c2_d_x = c2_c_x;
    c2_d_x = muDoubleScalarFloor(c2_d_x);
    if (c2_b_y == c2_d_x) {
      c2_e_x = c2_b_x / c2_b_y;
      c2_f_x = c2_e_x;
      c2_f_x = muDoubleScalarFloor(c2_f_x);
      c2_r = c2_b_x - c2_f_x * c2_b_y;
    } else {
      c2_r = c2_b_x / c2_b_y;
      c2_g_x = c2_r;
      c2_h_x = c2_g_x;
      c2_h_x = muDoubleScalarRound(c2_h_x);
      c2_i_x = c2_r - c2_h_x;
      c2_c_y = muDoubleScalarAbs(c2_i_x);
      c2_j_x = c2_r;
      c2_d_y = muDoubleScalarAbs(c2_j_x);
      c2_b = c2_d_y;
      c2_e_y = 2.2204460492503131E-16 * c2_b;
      if (c2_c_y <= c2_e_y) {
        c2_r = 0.0;
      } else {
        c2_k_x = c2_r;
        c2_l_x = c2_k_x;
        c2_l_x = muDoubleScalarFloor(c2_l_x);
        c2_r = (c2_r - c2_l_x) * c2_b_y;
      }
    }
  }

  return c2_r;
}

static void c2_b_eml_scalar_eg
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

static const mxArray *c2_g_sf_marshallOut(void *chartInstanceVoid, void
  *c2_inData)
{
  const mxArray *c2_mxArrayOutData = NULL;
  int32_T c2_u;
  const mxArray *c2_y = NULL;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_mxArrayOutData = NULL;
  c2_u = *(int32_T *)c2_inData;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c2_mxArrayOutData, c2_y, FALSE);
  return c2_mxArrayOutData;
}

static int32_T c2_g_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  int32_T c2_y;
  int32_T c2_i25;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_i25, 1, 6, 0U, 0, 0U, 0);
  c2_y = c2_i25;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void c2_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c2_mxArrayInData, const char_T *c2_varName, void *c2_outData)
{
  const mxArray *c2_b_sfEvent;
  const char_T *c2_identifier;
  emlrtMsgIdentifier c2_thisId;
  int32_T c2_y;
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    chartInstanceVoid;
  c2_b_sfEvent = sf_mex_dup(c2_mxArrayInData);
  c2_identifier = c2_varName;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c2_b_sfEvent),
    &c2_thisId);
  sf_mex_destroy(&c2_b_sfEvent);
  *(int32_T *)c2_outData = c2_y;
  sf_mex_destroy(&c2_mxArrayInData);
}

static uint8_T c2_h_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_b_is_active_c2_FeedbackLinearization_StateSpace, const char_T
   *c2_identifier)
{
  uint8_T c2_y;
  emlrtMsgIdentifier c2_thisId;
  c2_thisId.fIdentifier = c2_identifier;
  c2_thisId.fParent = NULL;
  c2_y = c2_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c2_b_is_active_c2_FeedbackLinearization_StateSpace), &c2_thisId);
  sf_mex_destroy(&c2_b_is_active_c2_FeedbackLinearization_StateSpace);
  return c2_y;
}

static uint8_T c2_i_emlrt_marshallIn
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance, const
   mxArray *c2_u, const emlrtMsgIdentifier *c2_parentId)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_parentId, sf_mex_dup(c2_u), &c2_u0, 1, 3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_u);
  return c2_y;
}

static void init_dsm_address_info
  (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c2_FeedbackLinearization_StateSpace_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(642941815U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(3296347235U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(811273689U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3701236078U);
}

mxArray *sf_c2_FeedbackLinearization_StateSpace_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("X3l6JVldkmxKpCBy1acPGB");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,7,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }

    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }

    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,6,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,6,"type",mxType);
    }

    mxSetField(mxData,6,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c2_FeedbackLinearization_StateSpace_third_party_uses_info(void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray *sf_get_sim_state_info_c2_FeedbackLinearization_StateSpace
  (void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x8'type','srcId','name','auxInfo'{{M[1],M[8],T\"E\",},{M[1],M[7],T\"E_c\",},{M[1],M[12],T\"LQR_control\",},{M[1],M[10],T\"state\",},{M[1],M[5],T\"tau\",},{M[1],M[14],T\"u\",},{M[1],M[6],T\"u0\",},{M[8],M[0],T\"is_active_c2_FeedbackLinearization_StateSpace\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 8, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_FeedbackLinearization_StateSpace_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
    chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _FeedbackLinearization_StateSpaceMachineNumber_,
           2,
           1,
           1,
           10,
           0,
           0,
           0,
           0,
           1,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_FeedbackLinearization_StateSpaceMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _FeedbackLinearization_StateSpaceMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _FeedbackLinearization_StateSpaceMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,"x");
          _SFD_SET_DATA_PROPS(1,1,1,0,"t");
          _SFD_SET_DATA_PROPS(2,2,0,1,"tau");
          _SFD_SET_DATA_PROPS(3,2,0,1,"u");
          _SFD_SET_DATA_PROPS(4,2,0,1,"u0");
          _SFD_SET_DATA_PROPS(5,2,0,1,"E_c");
          _SFD_SET_DATA_PROPS(6,2,0,1,"E");
          _SFD_SET_DATA_PROPS(7,2,0,1,"state");
          _SFD_SET_DATA_PROPS(8,1,1,0,"control_state");
          _SFD_SET_DATA_PROPS(9,2,0,1,"LQR_control");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,0,0,3,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2833);
        _SFD_CV_INIT_EML_IF(0,1,0,1606,1615,1670,1740);
        _SFD_CV_INIT_EML_IF(0,1,1,1780,1865,1996,2186);

        {
          static int condStart[] = { 1783, 1816, 1849 };

          static int condEnd[] = { 1812, 1845, 1865 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,1783,1865,3,0,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_CV_INIT_SCRIPT(0,1,3,0,0,0,0,0,7,3);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"hysteresis",0,-1,2103);
        _SFD_CV_INIT_SCRIPT_IF(0,0,1070,1143,1206,1557);
        _SFD_CV_INIT_SCRIPT_IF(0,1,1206,1298,1357,1557);
        _SFD_CV_INIT_SCRIPT_IF(0,2,1357,1432,1491,1557);

        {
          static int condStart[] = { 1073, 1110 };

          static int condEnd[] = { 1106, 1143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,0,1073,1143,2,0,&(condStart[0]),&(condEnd[0]),
            3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 1213, 1248, 1283 };

          static int condEnd[] = { 1244, 1279, 1298 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,1,1213,1298,3,2,&(condStart[0]),&(condEnd[0]),
            5,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 1364, 1400 };

          static int condEnd[] = { 1396, 1432 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,2,1364,1432,2,5,&(condStart[0]),&(condEnd[0]),
            3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          unsigned int dimVector[2];
          dimVector[0]= 6;
          dimVector[1]= 1;
          _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c2_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(6,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(7,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(8,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(9,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c2_sf_marshallOut,(MexInFcnForType)c2_sf_marshallIn);

        {
          real_T *c2_t;
          real_T *c2_tau;
          real_T *c2_u;
          real_T *c2_u0;
          real_T *c2_E_c;
          real_T *c2_E;
          real_T *c2_state;
          real_T *c2_control_state;
          real_T *c2_LQR_control;
          real_T (*c2_x)[6];
          c2_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 7);
          c2_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c2_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 6);
          c2_E = (real_T *)ssGetOutputPortSignal(chartInstance->S, 5);
          c2_E_c = (real_T *)ssGetOutputPortSignal(chartInstance->S, 4);
          c2_u0 = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c2_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c2_tau = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          c2_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c2_x = (real_T (*)[6])ssGetInputPortSignal(chartInstance->S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, *c2_x);
          _SFD_SET_DATA_VALUE_PTR(1U, c2_t);
          _SFD_SET_DATA_VALUE_PTR(2U, c2_tau);
          _SFD_SET_DATA_VALUE_PTR(3U, c2_u);
          _SFD_SET_DATA_VALUE_PTR(4U, c2_u0);
          _SFD_SET_DATA_VALUE_PTR(5U, c2_E_c);
          _SFD_SET_DATA_VALUE_PTR(6U, c2_E);
          _SFD_SET_DATA_VALUE_PTR(7U, c2_state);
          _SFD_SET_DATA_VALUE_PTR(8U, c2_control_state);
          _SFD_SET_DATA_VALUE_PTR(9U, c2_LQR_control);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _FeedbackLinearization_StateSpaceMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "PDFyderLx0TltF8qiWRBOG";
}

static void sf_opaque_initialize_c2_FeedbackLinearization_StateSpace(void
  *chartInstanceVar)
{
  chart_debug_initialization
    (((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar)
     ->S,0);
  initialize_params_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
  initialize_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_enable_c2_FeedbackLinearization_StateSpace(void
  *chartInstanceVar)
{
  enable_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_disable_c2_FeedbackLinearization_StateSpace(void
  *chartInstanceVar)
{
  disable_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
}

static void sf_opaque_gateway_c2_FeedbackLinearization_StateSpace(void
  *chartInstanceVar)
{
  sf_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c2_FeedbackLinearization_StateSpace(SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*) get_sim_state_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_FeedbackLinearization_StateSpace
    ();                                /* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void sf_internal_set_sim_state_c2_FeedbackLinearization_StateSpace
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*) sf_get_sim_state_info_c2_FeedbackLinearization_StateSpace
    ();                                /* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray*
  sf_opaque_get_sim_state_c2_FeedbackLinearization_StateSpace(SimStruct* S)
{
  return sf_internal_get_sim_state_c2_FeedbackLinearization_StateSpace(S);
}

static void sf_opaque_set_sim_state_c2_FeedbackLinearization_StateSpace
  (SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c2_FeedbackLinearization_StateSpace(S, st);
}

static void sf_opaque_terminate_c2_FeedbackLinearization_StateSpace(void
  *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S = ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*)
                    chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_FeedbackLinearization_StateSpace_optimization_info();
    }

    finalize_c2_FeedbackLinearization_StateSpace
      ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc2_FeedbackLinearization_StateSpace
    ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*) chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_FeedbackLinearization_StateSpace(SimStruct
  *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_FeedbackLinearization_StateSpace
      ((SFc2_FeedbackLinearization_StateSpaceInstanceStruct*)(((ChartInfoStruct *)
         ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c2_FeedbackLinearization_StateSpace(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct =
      load_FeedbackLinearization_StateSpace_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,2,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,2);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,2,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,2,7);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=7; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(415741693U));
  ssSetChecksum1(S,(2871690058U));
  ssSetChecksum2(S,(1379650708U));
  ssSetChecksum3(S,(3425251535U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c2_FeedbackLinearization_StateSpace(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_FeedbackLinearization_StateSpace(SimStruct *S)
{
  SFc2_FeedbackLinearization_StateSpaceInstanceStruct *chartInstance;
  chartInstance = (SFc2_FeedbackLinearization_StateSpaceInstanceStruct *)
    utMalloc(sizeof(SFc2_FeedbackLinearization_StateSpaceInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc2_FeedbackLinearization_StateSpaceInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW = mdlRTW_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.mdlStart =
    mdlStart_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c2_FeedbackLinearization_StateSpace;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c2_FeedbackLinearization_StateSpace_method_dispatcher(SimStruct *S, int_T
  method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_FeedbackLinearization_StateSpace(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_FeedbackLinearization_StateSpace(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_FeedbackLinearization_StateSpace(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_FeedbackLinearization_StateSpace_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
