/* Include files */

#include <stddef.h>
#include "blas.h"
#include "InvertedDoublePendulumSystem_KobayashiEtAl_sfun.h"
#include "c1_InvertedDoublePendulumSystem_KobayashiEtAl.h"
#include "mwmathutil.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance->chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance->instanceNumber)
#include "InvertedDoublePendulumSystem_KobayashiEtAl_sfun_debug_macros.h"
#define _SF_MEX_LISTEN_FOR_CTRL_C(S)   sf_mex_listen_for_ctrl_c(sfGlobalDebugInstanceStruct,S);

/* Type Definitions */

/* Named Constants */
#define CALL_EVENT                     (-1)

/* Variable Declarations */

/* Variable Definitions */
static const char * c1_debug_family_names[33] = { "l", "rb", "rp", "mb", "mp",
  "g", "Ib", "Ip", "thetab", "thetap", "dthetab", "dthetap", "E0", "E", "Ez",
  "mu", "epsilon", "beta_1", "beta_2", "LQR_lim_x1", "LQR_lim_x2", "limit",
  "x_lim", "x1_lim", "x2_lim", "nargin", "nargout", "x", "t", "control_state",
  "u", "LQR_control", "state" };

static const char * c1_b_debug_family_names[11] = { "x1_max_lim", "x2_max_lim",
  "x1_LQR_lim", "x2_LQR_lim", "nargin", "nargout", "x", "limit", "LQR_state",
  "x_lim", "LQR_control" };

static const char * c1_c_debug_family_names[11] = { "x1_max_lim", "x2_max_lim",
  "x1_LQR_lim", "x2_LQR_lim", "nargin", "nargout", "x", "limit", "LQR_state",
  "x_lim", "LQR_control" };

/* Function Declarations */
static void initialize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void initialize_params_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void enable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void disable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void c1_update_debugger_state_c1_InvertedDoublePendulumSystem_Kobayas
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static const mxArray
  *get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_st);
static void finalize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void c1_chartstep_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void initSimStructsc1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void registerMessagesc1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static void c1_hysteresis
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x[4], real_T c1_limit[4], boolean_T c1_LQR_state, real_T c1_x_lim[2],
   real_T *c1_LQR_control);
static void c1_b_hysteresis
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x[4], real_T c1_limit[4], real_T c1_LQR_state, real_T c1_x_lim[2],
   real_T *c1_LQR_control);
static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber);
static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData);
static real_T c1_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_state, const char_T *c1_identifier);
static real_T c1_b_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_c_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[2]);
static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static boolean_T c1_d_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static void c1_e_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[4]);
static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static const mxArray *c1_f_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static void c1_f_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[4]);
static void c1_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[52]);
static real_T c1_mpower
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_a);
static void c1_eml_scalar_eg
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static real_T c1_mod
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x, real_T c1_y);
static void c1_b_eml_scalar_eg
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);
static const mxArray *c1_g_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData);
static int32_T c1_g_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void c1_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData);
static uint8_T c1_h_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_b_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl,
   const char_T *c1_identifier);
static uint8_T c1_i_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId);
static void init_dsm_address_info
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance);

/* Function Definitions */
static void initialize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  chartInstance->c1_sfEvent = CALL_EVENT;
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  chartInstance->c1_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl = 0U;
}

static void initialize_params_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static void enable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void disable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
}

static void c1_update_debugger_state_c1_InvertedDoublePendulumSystem_Kobayas
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static const mxArray
  *get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  const mxArray *c1_st;
  const mxArray *c1_y = NULL;
  real_T c1_hoistedGlobal;
  real_T c1_u;
  const mxArray *c1_b_y = NULL;
  real_T c1_b_hoistedGlobal;
  real_T c1_b_u;
  const mxArray *c1_c_y = NULL;
  real_T c1_c_hoistedGlobal;
  real_T c1_c_u;
  const mxArray *c1_d_y = NULL;
  uint8_T c1_d_hoistedGlobal;
  uint8_T c1_d_u;
  const mxArray *c1_e_y = NULL;
  real_T *c1_LQR_control;
  real_T *c1_state;
  real_T *c1_e_u;
  c1_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c1_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c1_e_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  c1_st = NULL;
  c1_st = NULL;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_createcellarray(4), FALSE);
  c1_hoistedGlobal = *c1_LQR_control;
  c1_u = c1_hoistedGlobal;
  c1_b_y = NULL;
  sf_mex_assign(&c1_b_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 0, c1_b_y);
  c1_b_hoistedGlobal = *c1_state;
  c1_b_u = c1_b_hoistedGlobal;
  c1_c_y = NULL;
  sf_mex_assign(&c1_c_y, sf_mex_create("y", &c1_b_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 1, c1_c_y);
  c1_c_hoistedGlobal = *c1_e_u;
  c1_c_u = c1_c_hoistedGlobal;
  c1_d_y = NULL;
  sf_mex_assign(&c1_d_y, sf_mex_create("y", &c1_c_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 2, c1_d_y);
  c1_d_hoistedGlobal =
    chartInstance->c1_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  c1_d_u = c1_d_hoistedGlobal;
  c1_e_y = NULL;
  sf_mex_assign(&c1_e_y, sf_mex_create("y", &c1_d_u, 3, 0U, 0U, 0U, 0), FALSE);
  sf_mex_setcell(c1_y, 3, c1_e_y);
  sf_mex_assign(&c1_st, c1_y, FALSE);
  return c1_st;
}

static void set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_st)
{
  const mxArray *c1_u;
  real_T *c1_LQR_control;
  real_T *c1_state;
  real_T *c1_b_u;
  c1_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c1_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c1_b_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  chartInstance->c1_doneDoubleBufferReInit = TRUE;
  c1_u = sf_mex_dup(c1_st);
  *c1_LQR_control = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell
    (c1_u, 0)), "LQR_control");
  *c1_state = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u,
    1)), "state");
  *c1_b_u = c1_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 2)),
    "u");
  chartInstance->c1_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl =
    c1_h_emlrt_marshallIn(chartInstance, sf_mex_dup(sf_mex_getcell(c1_u, 3)),
    "is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl");
  sf_mex_destroy(&c1_u);
  c1_update_debugger_state_c1_InvertedDoublePendulumSystem_Kobayas(chartInstance);
  sf_mex_destroy(&c1_st);
}

static void finalize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static void sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  int32_T c1_i0;
  real_T *c1_u;
  real_T *c1_t;
  real_T *c1_control_state;
  real_T *c1_LQR_control;
  real_T *c1_state;
  real_T (*c1_x)[4];
  c1_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c1_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c1_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c1_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  c1_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance->S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  _SFD_DATA_RANGE_CHECK(*c1_u, 0U);
  for (c1_i0 = 0; c1_i0 < 4; c1_i0++) {
    _SFD_DATA_RANGE_CHECK((*c1_x)[c1_i0], 1U);
  }

  _SFD_DATA_RANGE_CHECK(*c1_t, 2U);
  _SFD_DATA_RANGE_CHECK(*c1_control_state, 3U);
  _SFD_DATA_RANGE_CHECK(*c1_LQR_control, 4U);
  _SFD_DATA_RANGE_CHECK(*c1_state, 5U);
  chartInstance->c1_sfEvent = CALL_EVENT;
  c1_chartstep_c1_InvertedDoublePendulumSystem_KobayashiEtAl(chartInstance);
  _SFD_CHECK_FOR_STATE_INCONSISTENCY
    (_InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
     chartInstance->chartNumber, chartInstance->instanceNumber);
}

static void c1_chartstep_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
  real_T c1_hoistedGlobal;
  real_T c1_b_hoistedGlobal;
  int32_T c1_i1;
  real_T c1_x[4];
  real_T c1_t;
  real_T c1_control_state;
  uint32_T c1_debug_family_var_map[33];
  real_T c1_l;
  real_T c1_rb;
  real_T c1_rp;
  real_T c1_mb;
  real_T c1_mp;
  real_T c1_g;
  real_T c1_Ib;
  real_T c1_Ip;
  real_T c1_thetab;
  real_T c1_thetap;
  real_T c1_dthetab;
  real_T c1_dthetap;
  real_T c1_E0;
  real_T c1_E;
  real_T c1_Ez;
  real_T c1_mu;
  real_T c1_epsilon;
  real_T c1_beta_1;
  real_T c1_beta_2;
  real_T c1_LQR_lim_x1;
  real_T c1_LQR_lim_x2;
  real_T c1_limit[4];
  real_T c1_x_lim[2];
  real_T c1_x1_lim;
  real_T c1_x2_lim;
  real_T c1_nargin = 3.0;
  real_T c1_nargout = 3.0;
  real_T c1_u;
  real_T c1_LQR_control;
  real_T c1_state;
  real_T c1_b;
  real_T c1_y;
  real_T c1_b_b;
  real_T c1_b_y;
  real_T c1_a;
  real_T c1_c_b;
  real_T c1_c_y;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_b_a;
  real_T c1_d_b;
  real_T c1_d_y;
  real_T c1_e_b;
  real_T c1_e_y;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_f_b;
  real_T c1_f_y;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_g_b;
  real_T c1_g_y;
  int32_T c1_i2;
  static real_T c1_dv0[4] = { 0.39269908169872414, 0.52359877559829882,
    0.010471975511965976, 0.020943951023931952 };

  int32_T c1_i3;
  real_T c1_h_x[4];
  int32_T c1_i4;
  real_T c1_dv1[4];
  real_T c1_b_LQR_control;
  real_T c1_b_x_lim[2];
  int32_T c1_i5;
  int32_T c1_i6;
  real_T c1_i_x[4];
  int32_T c1_i7;
  real_T c1_dv2[4];
  real_T c1_c_LQR_control;
  int32_T c1_i8;
  real_T c1_j_x;
  real_T c1_k_x;
  real_T c1_h_y;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_i_y;
  int32_T c1_i9;
  real_T c1_h_b[4];
  int32_T c1_k;
  int32_T c1_b_k;
  static real_T c1_dv3[4] = { 975.6281, 57.2364, 227.3441, 19.7419 };

  real_T c1_i_b;
  real_T c1_j_y;
  real_T c1_A;
  real_T c1_B;
  real_T c1_n_x;
  real_T c1_k_y;
  real_T c1_o_x;
  real_T c1_l_y;
  real_T *c1_b_t;
  real_T *c1_b_control_state;
  real_T *c1_b_u;
  real_T *c1_d_LQR_control;
  real_T *c1_b_state;
  real_T (*c1_p_x)[4];
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  c1_b_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
  c1_d_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
  c1_b_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
  c1_b_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
  c1_p_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
  c1_b_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
  c1_hoistedGlobal = *c1_b_t;
  c1_b_hoistedGlobal = *c1_b_control_state;
  for (c1_i1 = 0; c1_i1 < 4; c1_i1++) {
    c1_x[c1_i1] = (*c1_p_x)[c1_i1];
  }

  c1_t = c1_hoistedGlobal;
  c1_control_state = c1_b_hoistedGlobal;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 33U, 33U, c1_debug_family_names,
    c1_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_l, 0U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_rb, 1U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_rp, 2U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_mb, 3U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_mp, 4U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_g, 5U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_Ib, 6U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_Ip, 7U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_thetab, 8U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_thetap, 9U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_dthetab, 10U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_dthetap, 11U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_E0, 12U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_E, 13U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_Ez, 14U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_mu, 15U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_epsilon, 16U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_beta_1, 17U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_beta_2, 18U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_LQR_lim_x1, 19U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_LQR_lim_x2, 20U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_limit, 21U, c1_d_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x_lim, 22U, c1_c_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x1_lim, 23U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2_lim, 24U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargin, 25U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargout, 26U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML(c1_x, 27U, c1_b_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_t, 28U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML(&c1_control_state, 29U, c1_sf_marshallOut);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_u, 30U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_LQR_control, 31U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_state, 32U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 2);
  c1_l = 0.72;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 3);
  c1_rb = 0.4;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 4);
  c1_rp = 0.2;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 5);
  c1_mb = 31.118;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 6);
  c1_mp = 5.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 7);
  c1_g = 9.81;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 8);
  c1_Ib = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 9);
  c1_Ip = 0.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 21);
  c1_thetab = c1_x[0];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 22);
  c1_thetap = c1_x[1];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 23);
  c1_dthetab = c1_x[2];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 24);
  c1_dthetap = c1_x[3];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 27);
  c1_E0 = 167.233032;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 42);
  c1_b = c1_mpower(chartInstance, c1_x[2]);
  c1_y = 3.7854400000000004 * c1_b;
  c1_b_b = c1_x[2];
  c1_b_y = 0.72 * c1_b_b;
  c1_a = c1_b_y;
  c1_c_b = c1_x[2] + c1_x[3];
  c1_c_y = c1_a * c1_c_b;
  c1_b_x = c1_x[1];
  c1_c_x = c1_b_x;
  c1_c_x = muDoubleScalarCos(c1_c_x);
  c1_b_a = c1_c_y;
  c1_d_b = c1_c_x;
  c1_d_y = c1_b_a * c1_d_b;
  c1_e_b = c1_mpower(chartInstance, c1_x[2] + c1_x[3]);
  c1_e_y = 0.10000000000000002 * c1_e_b;
  c1_d_x = c1_x[0];
  c1_e_x = c1_d_x;
  c1_e_x = muDoubleScalarCos(c1_e_x);
  c1_f_b = c1_e_x;
  c1_f_y = 157.423032 * c1_f_b;
  c1_f_x = c1_x[0] + c1_x[1];
  c1_g_x = c1_f_x;
  c1_g_x = muDoubleScalarCos(c1_g_x);
  c1_g_b = c1_g_x;
  c1_g_y = 9.81 * c1_g_b;
  c1_E = (((c1_y + c1_d_y) + c1_e_y) + c1_f_y) + c1_g_y;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 46);
  c1_Ez = c1_E - c1_E0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 58);
  c1_mu = 100.0;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 59);
  c1_epsilon = 0.001;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 62);
  c1_beta_1 = 0.39269908169872414;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 63);
  c1_beta_2 = 0.52359877559829882;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 65);
  c1_LQR_lim_x1 = 0.010471975511965976;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 66);
  c1_LQR_lim_x2 = 0.020943951023931952;
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 68);
  for (c1_i2 = 0; c1_i2 < 4; c1_i2++) {
    c1_limit[c1_i2] = c1_dv0[c1_i2];
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 69);
  if (CV_EML_IF(0, 1, 0, c1_t == 0.0)) {
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 70);
    for (c1_i3 = 0; c1_i3 < 4; c1_i3++) {
      c1_h_x[c1_i3] = c1_x[c1_i3];
    }

    for (c1_i4 = 0; c1_i4 < 4; c1_i4++) {
      c1_dv1[c1_i4] = c1_dv0[c1_i4];
    }

    c1_hysteresis(chartInstance, c1_h_x, c1_dv1, FALSE, c1_b_x_lim,
                  &c1_b_LQR_control);
    for (c1_i5 = 0; c1_i5 < 2; c1_i5++) {
      c1_x_lim[c1_i5] = c1_b_x_lim[c1_i5];
    }

    c1_LQR_control = c1_b_LQR_control;
  } else {
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 72);
    for (c1_i6 = 0; c1_i6 < 4; c1_i6++) {
      c1_i_x[c1_i6] = c1_x[c1_i6];
    }

    for (c1_i7 = 0; c1_i7 < 4; c1_i7++) {
      c1_dv2[c1_i7] = c1_dv0[c1_i7];
    }

    c1_b_hysteresis(chartInstance, c1_i_x, c1_dv2, c1_control_state, c1_b_x_lim,
                    &c1_c_LQR_control);
    for (c1_i8 = 0; c1_i8 < 2; c1_i8++) {
      c1_x_lim[c1_i8] = c1_b_x_lim[c1_i8];
    }

    c1_LQR_control = c1_c_LQR_control;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 74);
  c1_x1_lim = c1_x_lim[0];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 75);
  c1_x2_lim = c1_x_lim[1];
  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 118);
  c1_j_x = c1_x[0];
  c1_k_x = c1_j_x;
  c1_h_y = muDoubleScalarAbs(c1_k_x);
  guard1 = FALSE;
  guard2 = FALSE;
  if (CV_EML_COND(0, 1, 0, c1_mod(chartInstance, c1_h_y, 6.2831853071795862) <=
                  c1_x1_lim)) {
    c1_l_x = c1_x[1];
    c1_m_x = c1_l_x;
    c1_i_y = muDoubleScalarAbs(c1_m_x);
    if (CV_EML_COND(0, 1, 1, c1_mod(chartInstance, c1_i_y, 6.2831853071795862) <=
                    c1_x2_lim)) {
      if (CV_EML_COND(0, 1, 2, c1_LQR_control == 1.0)) {
        CV_EML_MCDC(0, 1, 0, TRUE);
        CV_EML_IF(0, 1, 1, TRUE);
        _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 120);
        for (c1_i9 = 0; c1_i9 < 4; c1_i9++) {
          c1_h_b[c1_i9] = c1_x[c1_i9];
        }

        c1_b_eml_scalar_eg(chartInstance);
        c1_b_eml_scalar_eg(chartInstance);
        c1_u = 0.0;
        for (c1_k = 1; c1_k < 5; c1_k++) {
          c1_b_k = c1_k;
          c1_u += c1_dv3[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)
            _SFD_INTEGER_CHECK("", (real_T)c1_b_k), 1, 4, 1, 0) - 1] *
            c1_h_b[_SFD_EML_ARRAY_BOUNDS_CHECK("", (int32_T)_SFD_INTEGER_CHECK(
            "", (real_T)c1_b_k), 1, 4, 1, 0) - 1];
        }

        _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 121);
        c1_state = 2.0;
      } else {
        guard1 = TRUE;
      }
    } else {
      guard2 = TRUE;
    }
  } else {
    guard2 = TRUE;
  }

  if (guard2 == TRUE) {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_EML_MCDC(0, 1, 0, FALSE);
    CV_EML_IF(0, 1, 1, FALSE);
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 123);
    c1_i_b = c1_Ez;
    c1_j_y = -100.0 * c1_i_b;
    c1_A = c1_j_y;
    c1_B = c1_dthetap + c1_epsilon;
    c1_n_x = c1_A;
    c1_k_y = c1_B;
    c1_o_x = c1_n_x;
    c1_l_y = c1_k_y;
    c1_u = c1_o_x / c1_l_y;
    _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, 124);
    c1_state = 1.0;
  }

  _SFD_EML_CALL(0U, chartInstance->c1_sfEvent, -124);
  _SFD_SYMBOL_SCOPE_POP();
  *c1_b_u = c1_u;
  *c1_d_LQR_control = c1_LQR_control;
  *c1_b_state = c1_state;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG, 0U, chartInstance->c1_sfEvent);
}

static void initSimStructsc1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static void registerMessagesc1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static void c1_hysteresis
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x[4], real_T c1_limit[4], boolean_T c1_LQR_state, real_T c1_x_lim[2],
   real_T *c1_LQR_control)
{
  uint32_T c1_debug_family_var_map[11];
  real_T c1_x1_max_lim;
  real_T c1_x2_max_lim;
  real_T c1_x1_LQR_lim;
  real_T c1_x2_LQR_lim;
  real_T c1_nargin = 3.0;
  real_T c1_nargout = 2.0;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_y;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_b_y;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_c_y;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_d_y;
  real_T c1_j_x;
  real_T c1_k_x;
  real_T c1_e_y;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_f_y;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c1_b_debug_family_names,
    c1_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x1_max_lim, 0U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2_max_lim, 1U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x1_LQR_lim, 2U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2_LQR_lim, 3U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargin, 4U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargout, 5U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x, 6U, c1_f_sf_marshallOut,
    c1_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_limit, 7U, c1_d_sf_marshallOut,
    c1_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_LQR_state, 8U, c1_e_sf_marshallOut,
    c1_c_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x_lim, 9U, c1_c_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_LQR_control, 10U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 24);
  c1_x1_max_lim = c1_limit[0];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 25);
  c1_x2_max_lim = c1_limit[1];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 26);
  c1_x1_LQR_lim = c1_limit[2];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 27);
  c1_x2_LQR_lim = c1_limit[3];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 29);
  c1_b_x = c1_x[0];
  c1_c_x = c1_b_x;
  c1_y = muDoubleScalarAbs(c1_c_x);
  guard1 = FALSE;
  if (CV_SCRIPT_COND(0, 0, c1_mod(chartInstance, c1_y, 6.2831853071795862) <=
                     c1_x1_LQR_lim)) {
    c1_d_x = c1_x[1];
    c1_e_x = c1_d_x;
    c1_b_y = muDoubleScalarAbs(c1_e_x);
    if (CV_SCRIPT_COND(0, 1, c1_mod(chartInstance, c1_b_y, 6.2831853071795862) <=
                       c1_x2_LQR_lim)) {
      CV_SCRIPT_MCDC(0, 0, TRUE);
      CV_SCRIPT_IF(0, 0, TRUE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 30);
      c1_x_lim[0] = c1_x1_max_lim;
      c1_x_lim[1] = c1_x2_max_lim;
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 31);
      *c1_LQR_control = 1.0;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_SCRIPT_MCDC(0, 0, FALSE);
    CV_SCRIPT_IF(0, 0, FALSE);
    _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 32);
    c1_f_x = c1_x[0];
    c1_g_x = c1_f_x;
    c1_c_y = muDoubleScalarAbs(c1_g_x);
    guard2 = FALSE;
    guard3 = FALSE;
    if (CV_SCRIPT_COND(0, 2, c1_mod(chartInstance, c1_c_y, 6.2831853071795862) <=
                       c1_x1_max_lim)) {
      c1_h_x = c1_x[1];
      c1_i_x = c1_h_x;
      c1_d_y = muDoubleScalarAbs(c1_i_x);
      if (CV_SCRIPT_COND(0, 3, c1_mod(chartInstance, c1_d_y, 6.2831853071795862)
                         <= c1_x2_max_lim)) {
        if (CV_SCRIPT_COND(0, 4, c1_LQR_state)) {
          CV_SCRIPT_MCDC(0, 1, TRUE);
          CV_SCRIPT_IF(0, 1, TRUE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 33);
          c1_x_lim[0] = c1_x1_max_lim;
          c1_x_lim[1] = c1_x2_max_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 34);
          *c1_LQR_control = 1.0;
        } else {
          guard2 = TRUE;
        }
      } else {
        guard3 = TRUE;
      }
    } else {
      guard3 = TRUE;
    }

    if (guard3 == TRUE) {
      guard2 = TRUE;
    }

    if (guard2 == TRUE) {
      CV_SCRIPT_MCDC(0, 1, FALSE);
      CV_SCRIPT_IF(0, 1, FALSE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 35);
      c1_j_x = c1_x[0];
      c1_k_x = c1_j_x;
      c1_e_y = muDoubleScalarAbs(c1_k_x);
      guard4 = FALSE;
      if (CV_SCRIPT_COND(0, 5, c1_mod(chartInstance, c1_e_y, 6.2831853071795862)
                         > c1_x1_max_lim)) {
        guard4 = TRUE;
      } else {
        c1_l_x = c1_x[1];
        c1_m_x = c1_l_x;
        c1_f_y = muDoubleScalarAbs(c1_m_x);
        if (CV_SCRIPT_COND(0, 6, c1_mod(chartInstance, c1_f_y,
              6.2831853071795862) > c1_x2_max_lim)) {
          guard4 = TRUE;
        } else {
          CV_SCRIPT_MCDC(0, 2, FALSE);
          CV_SCRIPT_IF(0, 2, FALSE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 39);
          c1_x_lim[0] = c1_x1_LQR_lim;
          c1_x_lim[1] = c1_x2_LQR_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 40);
          *c1_LQR_control = 0.0;
        }
      }

      if (guard4 == TRUE) {
        CV_SCRIPT_MCDC(0, 2, TRUE);
        CV_SCRIPT_IF(0, 2, TRUE);
        _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 36);
        c1_x_lim[0] = c1_x1_LQR_lim;
        c1_x_lim[1] = c1_x2_LQR_lim;
        _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 37);
        *c1_LQR_control = 0.0;
      }
    }
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, -40);
  _SFD_SYMBOL_SCOPE_POP();
}

static void c1_b_hysteresis
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x[4], real_T c1_limit[4], real_T c1_LQR_state, real_T c1_x_lim[2],
   real_T *c1_LQR_control)
{
  uint32_T c1_debug_family_var_map[11];
  real_T c1_x1_max_lim;
  real_T c1_x2_max_lim;
  real_T c1_x1_LQR_lim;
  real_T c1_x2_LQR_lim;
  real_T c1_nargin = 3.0;
  real_T c1_nargout = 2.0;
  real_T c1_b_x;
  real_T c1_c_x;
  real_T c1_y;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_b_y;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_c_y;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_d_y;
  real_T c1_j_x;
  real_T c1_k_x;
  real_T c1_e_y;
  real_T c1_l_x;
  real_T c1_m_x;
  real_T c1_f_y;
  boolean_T guard1 = FALSE;
  boolean_T guard2 = FALSE;
  boolean_T guard3 = FALSE;
  boolean_T guard4 = FALSE;
  _SFD_SYMBOL_SCOPE_PUSH_EML(0U, 11U, 11U, c1_c_debug_family_names,
    c1_debug_family_var_map);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x1_max_lim, 0U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2_max_lim, 1U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x1_LQR_lim, 2U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_x2_LQR_lim, 3U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargin, 4U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_nargout, 5U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x, 6U, c1_f_sf_marshallOut,
    c1_e_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_limit, 7U, c1_d_sf_marshallOut,
    c1_d_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(&c1_LQR_state, 8U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_x_lim, 9U, c1_c_sf_marshallOut,
    c1_b_sf_marshallIn);
  _SFD_SYMBOL_SCOPE_ADD_EML_IMPORTABLE(c1_LQR_control, 10U, c1_sf_marshallOut,
    c1_sf_marshallIn);
  CV_SCRIPT_FCN(0, 0);
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 24);
  c1_x1_max_lim = c1_limit[0];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 25);
  c1_x2_max_lim = c1_limit[1];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 26);
  c1_x1_LQR_lim = c1_limit[2];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 27);
  c1_x2_LQR_lim = c1_limit[3];
  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 29);
  c1_b_x = c1_x[0];
  c1_c_x = c1_b_x;
  c1_y = muDoubleScalarAbs(c1_c_x);
  guard1 = FALSE;
  if (CV_SCRIPT_COND(0, 0, c1_mod(chartInstance, c1_y, 6.2831853071795862) <=
                     c1_x1_LQR_lim)) {
    c1_d_x = c1_x[1];
    c1_e_x = c1_d_x;
    c1_b_y = muDoubleScalarAbs(c1_e_x);
    if (CV_SCRIPT_COND(0, 1, c1_mod(chartInstance, c1_b_y, 6.2831853071795862) <=
                       c1_x2_LQR_lim)) {
      CV_SCRIPT_MCDC(0, 0, TRUE);
      CV_SCRIPT_IF(0, 0, TRUE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 30);
      c1_x_lim[0] = c1_x1_max_lim;
      c1_x_lim[1] = c1_x2_max_lim;
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 31);
      *c1_LQR_control = 1.0;
    } else {
      guard1 = TRUE;
    }
  } else {
    guard1 = TRUE;
  }

  if (guard1 == TRUE) {
    CV_SCRIPT_MCDC(0, 0, FALSE);
    CV_SCRIPT_IF(0, 0, FALSE);
    _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 32);
    c1_f_x = c1_x[0];
    c1_g_x = c1_f_x;
    c1_c_y = muDoubleScalarAbs(c1_g_x);
    guard2 = FALSE;
    guard3 = FALSE;
    if (CV_SCRIPT_COND(0, 2, c1_mod(chartInstance, c1_c_y, 6.2831853071795862) <=
                       c1_x1_max_lim)) {
      c1_h_x = c1_x[1];
      c1_i_x = c1_h_x;
      c1_d_y = muDoubleScalarAbs(c1_i_x);
      if (CV_SCRIPT_COND(0, 3, c1_mod(chartInstance, c1_d_y, 6.2831853071795862)
                         <= c1_x2_max_lim)) {
        if (CV_SCRIPT_COND(0, 4, c1_LQR_state == 1.0)) {
          CV_SCRIPT_MCDC(0, 1, TRUE);
          CV_SCRIPT_IF(0, 1, TRUE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 33);
          c1_x_lim[0] = c1_x1_max_lim;
          c1_x_lim[1] = c1_x2_max_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 34);
          *c1_LQR_control = 1.0;
        } else {
          guard2 = TRUE;
        }
      } else {
        guard3 = TRUE;
      }
    } else {
      guard3 = TRUE;
    }

    if (guard3 == TRUE) {
      guard2 = TRUE;
    }

    if (guard2 == TRUE) {
      CV_SCRIPT_MCDC(0, 1, FALSE);
      CV_SCRIPT_IF(0, 1, FALSE);
      _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 35);
      c1_j_x = c1_x[0];
      c1_k_x = c1_j_x;
      c1_e_y = muDoubleScalarAbs(c1_k_x);
      guard4 = FALSE;
      if (CV_SCRIPT_COND(0, 5, c1_mod(chartInstance, c1_e_y, 6.2831853071795862)
                         > c1_x1_max_lim)) {
        guard4 = TRUE;
      } else {
        c1_l_x = c1_x[1];
        c1_m_x = c1_l_x;
        c1_f_y = muDoubleScalarAbs(c1_m_x);
        if (CV_SCRIPT_COND(0, 6, c1_mod(chartInstance, c1_f_y,
              6.2831853071795862) > c1_x2_max_lim)) {
          guard4 = TRUE;
        } else {
          CV_SCRIPT_MCDC(0, 2, FALSE);
          CV_SCRIPT_IF(0, 2, FALSE);
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 39);
          c1_x_lim[0] = c1_x1_LQR_lim;
          c1_x_lim[1] = c1_x2_LQR_lim;
          _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 40);
          *c1_LQR_control = 0.0;
        }
      }

      if (guard4 == TRUE) {
        CV_SCRIPT_MCDC(0, 2, TRUE);
        CV_SCRIPT_IF(0, 2, TRUE);
        _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 36);
        c1_x_lim[0] = c1_x1_LQR_lim;
        c1_x_lim[1] = c1_x2_LQR_lim;
        _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, 37);
        *c1_LQR_control = 0.0;
      }
    }
  }

  _SFD_SCRIPT_CALL(0U, chartInstance->c1_sfEvent, -40);
  _SFD_SYMBOL_SCOPE_POP();
}

static void init_script_number_translation(uint32_T c1_machineNumber, uint32_T
  c1_chartNumber)
{
  _SFD_SCRIPT_TRANSLATION(c1_chartNumber, 0U, sf_debug_get_script_id(
    "C:/Users/jorgni/Documents/Masteroppgave/Matlab/Controller by Kobayashi et al/hysteresis.m"));
}

static const mxArray *c1_sf_marshallOut(void *chartInstanceVoid, void *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  real_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(real_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 0, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static real_T c1_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_state, const char_T *c1_identifier)
{
  real_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_state), &c1_thisId);
  sf_mex_destroy(&c1_state);
  return c1_y;
}

static real_T c1_b_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  real_T c1_y;
  real_T c1_d0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_d0, 1, 0, 0U, 0, 0U, 0);
  c1_y = c1_d0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_state;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_state = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_b_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_state), &c1_thisId);
  sf_mex_destroy(&c1_state);
  *(real_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_b_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i10;
  real_T c1_b_inData[4];
  int32_T c1_i11;
  real_T c1_u[4];
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i10 = 0; c1_i10 < 4; c1_i10++) {
    c1_b_inData[c1_i10] = (*(real_T (*)[4])c1_inData)[c1_i10];
  }

  for (c1_i11 = 0; c1_i11 < 4; c1_i11++) {
    c1_u[c1_i11] = c1_b_inData[c1_i11];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 4, 1), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static const mxArray *c1_c_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i12;
  real_T c1_b_inData[2];
  int32_T c1_i13;
  real_T c1_u[2];
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i12 = 0; c1_i12 < 2; c1_i12++) {
    c1_b_inData[c1_i12] = (*(real_T (*)[2])c1_inData)[c1_i12];
  }

  for (c1_i13 = 0; c1_i13 < 2; c1_i13++) {
    c1_u[c1_i13] = c1_b_inData[c1_i13];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 1, 2), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_c_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[2])
{
  real_T c1_dv4[2];
  int32_T c1_i14;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv4, 1, 0, 0U, 1, 0U, 2, 1, 2);
  for (c1_i14 = 0; c1_i14 < 2; c1_i14++) {
    c1_y[c1_i14] = c1_dv4[c1_i14];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_b_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_x_lim;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[2];
  int32_T c1_i15;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_x_lim = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_c_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_x_lim), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_x_lim);
  for (c1_i15 = 0; c1_i15 < 2; c1_i15++) {
    (*(real_T (*)[2])c1_outData)[c1_i15] = c1_y[c1_i15];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_d_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i16;
  real_T c1_b_inData[4];
  int32_T c1_i17;
  real_T c1_u[4];
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i16 = 0; c1_i16 < 4; c1_i16++) {
    c1_b_inData[c1_i16] = (*(real_T (*)[4])c1_inData)[c1_i16];
  }

  for (c1_i17 = 0; c1_i17 < 4; c1_i17++) {
    c1_u[c1_i17] = c1_b_inData[c1_i17];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 2, 1, 4), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static const mxArray *c1_e_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  boolean_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(boolean_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 11, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static boolean_T c1_d_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  boolean_T c1_y;
  boolean_T c1_b0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_b0, 1, 11, 0U, 0, 0U, 0);
  c1_y = c1_b0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_c_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_LQR_state;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  boolean_T c1_y;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_LQR_state = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_d_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_LQR_state),
    &c1_thisId);
  sf_mex_destroy(&c1_LQR_state);
  *(boolean_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static void c1_e_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[4])
{
  real_T c1_dv5[4];
  int32_T c1_i18;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv5, 1, 0, 0U, 1, 0U, 2, 1, 4);
  for (c1_i18 = 0; c1_i18 < 4; c1_i18++) {
    c1_y[c1_i18] = c1_dv5[c1_i18];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_d_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_limit;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[4];
  int32_T c1_i19;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_limit = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_e_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_limit), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_limit);
  for (c1_i19 = 0; c1_i19 < 4; c1_i19++) {
    (*(real_T (*)[4])c1_outData)[c1_i19] = c1_y[c1_i19];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

static const mxArray *c1_f_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_i20;
  real_T c1_b_inData[4];
  int32_T c1_i21;
  real_T c1_u[4];
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  for (c1_i20 = 0; c1_i20 < 4; c1_i20++) {
    c1_b_inData[c1_i20] = (*(real_T (*)[4])c1_inData)[c1_i20];
  }

  for (c1_i21 = 0; c1_i21 < 4; c1_i21++) {
    c1_u[c1_i21] = c1_b_inData[c1_i21];
  }

  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", c1_u, 0, 0U, 1U, 0U, 1, 4), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static void c1_f_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId, real_T c1_y[4])
{
  real_T c1_dv6[4];
  int32_T c1_i22;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), c1_dv6, 1, 0, 0U, 1, 0U, 1, 4);
  for (c1_i22 = 0; c1_i22 < 4; c1_i22++) {
    c1_y[c1_i22] = c1_dv6[c1_i22];
  }

  sf_mex_destroy(&c1_u);
}

static void c1_e_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_x;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  real_T c1_y[4];
  int32_T c1_i23;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_x = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_f_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_x), &c1_thisId, c1_y);
  sf_mex_destroy(&c1_x);
  for (c1_i23 = 0; c1_i23 < 4; c1_i23++) {
    (*(real_T (*)[4])c1_outData)[c1_i23] = c1_y[c1_i23];
  }

  sf_mex_destroy(&c1_mxArrayInData);
}

const mxArray
  *sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl_get_eml_resolved_functions_info
  (void)
{
  const mxArray *c1_nameCaptureInfo;
  c1_ResolvedFunctionInfo c1_info[52];
  const mxArray *c1_m0 = NULL;
  int32_T c1_i24;
  c1_ResolvedFunctionInfo *c1_r0;
  c1_nameCaptureInfo = NULL;
  c1_nameCaptureInfo = NULL;
  c1_info_helper(c1_info);
  sf_mex_assign(&c1_m0, sf_mex_createstruct("nameCaptureInfo", 1, 52), FALSE);
  for (c1_i24 = 0; c1_i24 < 52; c1_i24++) {
    c1_r0 = &c1_info[c1_i24];
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->context)), "context", "nameCaptureInfo",
                    c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c1_r0->name)), "name", "nameCaptureInfo", c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c1_r0->dominantType)), "dominantType",
                    "nameCaptureInfo", c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", c1_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c1_r0->resolved)), "resolved", "nameCaptureInfo",
                    c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeLo,
      7, 0U, 0U, 0U, 0), "fileTimeLo", "nameCaptureInfo", c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->fileTimeHi,
      7, 0U, 0U, 0U, 0), "fileTimeHi", "nameCaptureInfo", c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeLo,
      7, 0U, 0U, 0U, 0), "mFileTimeLo", "nameCaptureInfo", c1_i24);
    sf_mex_addfield(c1_m0, sf_mex_create("nameCaptureInfo", &c1_r0->mFileTimeHi,
      7, 0U, 0U, 0U, 0), "mFileTimeHi", "nameCaptureInfo", c1_i24);
  }

  sf_mex_assign(&c1_nameCaptureInfo, c1_m0, FALSE);
  sf_mex_emlrtNameCapturePostProcessR2012a(&c1_nameCaptureInfo);
  return c1_nameCaptureInfo;
}

static void c1_info_helper(c1_ResolvedFunctionInfo c1_info[52])
{
  c1_info[0].context = "";
  c1_info[0].name = "mtimes";
  c1_info[0].dominantType = "double";
  c1_info[0].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[0].fileTimeLo = 1289519692U;
  c1_info[0].fileTimeHi = 0U;
  c1_info[0].mFileTimeLo = 0U;
  c1_info[0].mFileTimeHi = 0U;
  c1_info[1].context = "";
  c1_info[1].name = "mrdivide";
  c1_info[1].dominantType = "double";
  c1_info[1].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[1].fileTimeLo = 1357951548U;
  c1_info[1].fileTimeHi = 0U;
  c1_info[1].mFileTimeLo = 1319729966U;
  c1_info[1].mFileTimeHi = 0U;
  c1_info[2].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mrdivide.p";
  c1_info[2].name = "rdivide";
  c1_info[2].dominantType = "double";
  c1_info[2].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[2].fileTimeLo = 1346510388U;
  c1_info[2].fileTimeHi = 0U;
  c1_info[2].mFileTimeLo = 0U;
  c1_info[2].mFileTimeHi = 0U;
  c1_info[3].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[3].name = "eml_scalexp_compatible";
  c1_info[3].dominantType = "double";
  c1_info[3].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_compatible.m";
  c1_info[3].fileTimeLo = 1286818796U;
  c1_info[3].fileTimeHi = 0U;
  c1_info[3].mFileTimeLo = 0U;
  c1_info[3].mFileTimeHi = 0U;
  c1_info[4].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/rdivide.m";
  c1_info[4].name = "eml_div";
  c1_info[4].dominantType = "double";
  c1_info[4].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_div.m";
  c1_info[4].fileTimeLo = 1313347810U;
  c1_info[4].fileTimeHi = 0U;
  c1_info[4].mFileTimeLo = 0U;
  c1_info[4].mFileTimeHi = 0U;
  c1_info[5].context = "";
  c1_info[5].name = "mpower";
  c1_info[5].dominantType = "double";
  c1_info[5].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[5].fileTimeLo = 1286818842U;
  c1_info[5].fileTimeHi = 0U;
  c1_info[5].mFileTimeLo = 0U;
  c1_info[5].mFileTimeHi = 0U;
  c1_info[6].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mpower.m";
  c1_info[6].name = "power";
  c1_info[6].dominantType = "double";
  c1_info[6].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m";
  c1_info[6].fileTimeLo = 1348191930U;
  c1_info[6].fileTimeHi = 0U;
  c1_info[6].mFileTimeLo = 0U;
  c1_info[6].mFileTimeHi = 0U;
  c1_info[7].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c1_info[7].name = "eml_scalar_eg";
  c1_info[7].dominantType = "double";
  c1_info[7].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[7].fileTimeLo = 1286818796U;
  c1_info[7].fileTimeHi = 0U;
  c1_info[7].mFileTimeLo = 0U;
  c1_info[7].mFileTimeHi = 0U;
  c1_info[8].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c1_info[8].name = "eml_scalexp_alloc";
  c1_info[8].dominantType = "double";
  c1_info[8].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c1_info[8].fileTimeLo = 1352424860U;
  c1_info[8].fileTimeHi = 0U;
  c1_info[8].mFileTimeLo = 0U;
  c1_info[8].mFileTimeHi = 0U;
  c1_info[9].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!fltpower";
  c1_info[9].name = "floor";
  c1_info[9].dominantType = "double";
  c1_info[9].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c1_info[9].fileTimeLo = 1343830380U;
  c1_info[9].fileTimeHi = 0U;
  c1_info[9].mFileTimeLo = 0U;
  c1_info[9].mFileTimeHi = 0U;
  c1_info[10].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/floor.m";
  c1_info[10].name = "eml_scalar_floor";
  c1_info[10].dominantType = "double";
  c1_info[10].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c1_info[10].fileTimeLo = 1286818726U;
  c1_info[10].fileTimeHi = 0U;
  c1_info[10].mFileTimeLo = 0U;
  c1_info[10].mFileTimeHi = 0U;
  c1_info[11].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c1_info[11].name = "eml_scalar_eg";
  c1_info[11].dominantType = "double";
  c1_info[11].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[11].fileTimeLo = 1286818796U;
  c1_info[11].fileTimeHi = 0U;
  c1_info[11].mFileTimeLo = 0U;
  c1_info[11].mFileTimeHi = 0U;
  c1_info[12].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/power.m!scalar_float_power";
  c1_info[12].name = "mtimes";
  c1_info[12].dominantType = "double";
  c1_info[12].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[12].fileTimeLo = 1289519692U;
  c1_info[12].fileTimeHi = 0U;
  c1_info[12].mFileTimeLo = 0U;
  c1_info[12].mFileTimeHi = 0U;
  c1_info[13].context = "";
  c1_info[13].name = "cos";
  c1_info[13].dominantType = "double";
  c1_info[13].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[13].fileTimeLo = 1343830372U;
  c1_info[13].fileTimeHi = 0U;
  c1_info[13].mFileTimeLo = 0U;
  c1_info[13].mFileTimeHi = 0U;
  c1_info[14].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/cos.m";
  c1_info[14].name = "eml_scalar_cos";
  c1_info[14].dominantType = "double";
  c1_info[14].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_cos.m";
  c1_info[14].fileTimeLo = 1286818722U;
  c1_info[14].fileTimeHi = 0U;
  c1_info[14].mFileTimeLo = 0U;
  c1_info[14].mFileTimeHi = 0U;
  c1_info[15].context = "";
  c1_info[15].name = "hysteresis";
  c1_info[15].dominantType = "double";
  c1_info[15].resolved =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Controller by Kobayashi et al/hysteresis.m";
  c1_info[15].fileTimeLo = 1398243731U;
  c1_info[15].fileTimeHi = 0U;
  c1_info[15].mFileTimeLo = 0U;
  c1_info[15].mFileTimeHi = 0U;
  c1_info[16].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Controller by Kobayashi et al/hysteresis.m";
  c1_info[16].name = "abs";
  c1_info[16].dominantType = "double";
  c1_info[16].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[16].fileTimeLo = 1343830366U;
  c1_info[16].fileTimeHi = 0U;
  c1_info[16].mFileTimeLo = 0U;
  c1_info[16].mFileTimeHi = 0U;
  c1_info[17].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[17].name = "eml_scalar_abs";
  c1_info[17].dominantType = "double";
  c1_info[17].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[17].fileTimeLo = 1286818712U;
  c1_info[17].fileTimeHi = 0U;
  c1_info[17].mFileTimeLo = 0U;
  c1_info[17].mFileTimeHi = 0U;
  c1_info[18].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Controller by Kobayashi et al/hysteresis.m";
  c1_info[18].name = "mtimes";
  c1_info[18].dominantType = "double";
  c1_info[18].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[18].fileTimeLo = 1289519692U;
  c1_info[18].fileTimeHi = 0U;
  c1_info[18].mFileTimeLo = 0U;
  c1_info[18].mFileTimeHi = 0U;
  c1_info[19].context =
    "[E]C:/Users/jorgni/Documents/Masteroppgave/Matlab/Controller by Kobayashi et al/hysteresis.m";
  c1_info[19].name = "mod";
  c1_info[19].dominantType = "double";
  c1_info[19].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c1_info[19].fileTimeLo = 1343830382U;
  c1_info[19].fileTimeHi = 0U;
  c1_info[19].mFileTimeLo = 0U;
  c1_info[19].mFileTimeHi = 0U;
  c1_info[20].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c1_info[20].name = "eml_scalar_eg";
  c1_info[20].dominantType = "double";
  c1_info[20].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[20].fileTimeLo = 1286818796U;
  c1_info[20].fileTimeHi = 0U;
  c1_info[20].mFileTimeLo = 0U;
  c1_info[20].mFileTimeHi = 0U;
  c1_info[21].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c1_info[21].name = "eml_scalexp_alloc";
  c1_info[21].dominantType = "double";
  c1_info[21].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalexp_alloc.m";
  c1_info[21].fileTimeLo = 1352424860U;
  c1_info[21].fileTimeHi = 0U;
  c1_info[21].mFileTimeLo = 0U;
  c1_info[21].mFileTimeHi = 0U;
  c1_info[22].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[22].name = "eml_scalar_eg";
  c1_info[22].dominantType = "double";
  c1_info[22].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[22].fileTimeLo = 1286818796U;
  c1_info[22].fileTimeHi = 0U;
  c1_info[22].mFileTimeLo = 0U;
  c1_info[22].mFileTimeHi = 0U;
  c1_info[23].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[23].name = "eml_scalar_floor";
  c1_info[23].dominantType = "double";
  c1_info[23].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_floor.m";
  c1_info[23].fileTimeLo = 1286818726U;
  c1_info[23].fileTimeHi = 0U;
  c1_info[23].mFileTimeLo = 0U;
  c1_info[23].mFileTimeHi = 0U;
  c1_info[24].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[24].name = "eml_scalar_round";
  c1_info[24].dominantType = "double";
  c1_info[24].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_round.m";
  c1_info[24].fileTimeLo = 1307651238U;
  c1_info[24].fileTimeHi = 0U;
  c1_info[24].mFileTimeLo = 0U;
  c1_info[24].mFileTimeHi = 0U;
  c1_info[25].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[25].name = "eml_scalar_abs";
  c1_info[25].dominantType = "double";
  c1_info[25].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/eml_scalar_abs.m";
  c1_info[25].fileTimeLo = 1286818712U;
  c1_info[25].fileTimeHi = 0U;
  c1_info[25].mFileTimeLo = 0U;
  c1_info[25].mFileTimeHi = 0U;
  c1_info[26].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[26].name = "eps";
  c1_info[26].dominantType = "char";
  c1_info[26].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c1_info[26].fileTimeLo = 1326727996U;
  c1_info[26].fileTimeHi = 0U;
  c1_info[26].mFileTimeLo = 0U;
  c1_info[26].mFileTimeHi = 0U;
  c1_info[27].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c1_info[27].name = "eml_is_float_class";
  c1_info[27].dominantType = "char";
  c1_info[27].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_is_float_class.m";
  c1_info[27].fileTimeLo = 1286818782U;
  c1_info[27].fileTimeHi = 0U;
  c1_info[27].mFileTimeLo = 0U;
  c1_info[27].mFileTimeHi = 0U;
  c1_info[28].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/eps.m";
  c1_info[28].name = "eml_eps";
  c1_info[28].dominantType = "char";
  c1_info[28].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c1_info[28].fileTimeLo = 1326727996U;
  c1_info[28].fileTimeHi = 0U;
  c1_info[28].mFileTimeLo = 0U;
  c1_info[28].mFileTimeHi = 0U;
  c1_info[29].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_eps.m";
  c1_info[29].name = "eml_float_model";
  c1_info[29].dominantType = "char";
  c1_info[29].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_float_model.m";
  c1_info[29].fileTimeLo = 1326727996U;
  c1_info[29].fileTimeHi = 0U;
  c1_info[29].mFileTimeLo = 0U;
  c1_info[29].mFileTimeHi = 0U;
  c1_info[30].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m!floatmod";
  c1_info[30].name = "mtimes";
  c1_info[30].dominantType = "double";
  c1_info[30].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[30].fileTimeLo = 1289519692U;
  c1_info[30].fileTimeHi = 0U;
  c1_info[30].mFileTimeLo = 0U;
  c1_info[30].mFileTimeHi = 0U;
  c1_info[31].context = "";
  c1_info[31].name = "abs";
  c1_info[31].dominantType = "double";
  c1_info[31].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/abs.m";
  c1_info[31].fileTimeLo = 1343830366U;
  c1_info[31].fileTimeHi = 0U;
  c1_info[31].mFileTimeLo = 0U;
  c1_info[31].mFileTimeHi = 0U;
  c1_info[32].context = "";
  c1_info[32].name = "mod";
  c1_info[32].dominantType = "double";
  c1_info[32].resolved = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elfun/mod.m";
  c1_info[32].fileTimeLo = 1343830382U;
  c1_info[32].fileTimeHi = 0U;
  c1_info[32].mFileTimeLo = 0U;
  c1_info[32].mFileTimeHi = 0U;
  c1_info[33].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[33].name = "eml_index_class";
  c1_info[33].dominantType = "";
  c1_info[33].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[33].fileTimeLo = 1323170578U;
  c1_info[33].fileTimeHi = 0U;
  c1_info[33].mFileTimeLo = 0U;
  c1_info[33].mFileTimeHi = 0U;
  c1_info[34].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[34].name = "eml_scalar_eg";
  c1_info[34].dominantType = "double";
  c1_info[34].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[34].fileTimeLo = 1286818796U;
  c1_info[34].fileTimeHi = 0U;
  c1_info[34].mFileTimeLo = 0U;
  c1_info[34].mFileTimeHi = 0U;
  c1_info[35].context = "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/ops/mtimes.m";
  c1_info[35].name = "eml_xdotu";
  c1_info[35].dominantType = "double";
  c1_info[35].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[35].fileTimeLo = 1299076772U;
  c1_info[35].fileTimeHi = 0U;
  c1_info[35].mFileTimeLo = 0U;
  c1_info[35].mFileTimeHi = 0U;
  c1_info[36].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[36].name = "eml_blas_inline";
  c1_info[36].dominantType = "";
  c1_info[36].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[36].fileTimeLo = 1299076768U;
  c1_info[36].fileTimeHi = 0U;
  c1_info[36].mFileTimeLo = 0U;
  c1_info[36].mFileTimeHi = 0U;
  c1_info[37].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdotu.m";
  c1_info[37].name = "eml_xdot";
  c1_info[37].dominantType = "double";
  c1_info[37].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c1_info[37].fileTimeLo = 1299076772U;
  c1_info[37].fileTimeHi = 0U;
  c1_info[37].mFileTimeLo = 0U;
  c1_info[37].mFileTimeHi = 0U;
  c1_info[38].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_xdot.m";
  c1_info[38].name = "eml_blas_inline";
  c1_info[38].dominantType = "";
  c1_info[38].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/eml_blas_inline.m";
  c1_info[38].fileTimeLo = 1299076768U;
  c1_info[38].fileTimeHi = 0U;
  c1_info[38].mFileTimeLo = 0U;
  c1_info[38].mFileTimeHi = 0U;
  c1_info[39].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c1_info[39].name = "eml_index_class";
  c1_info[39].dominantType = "";
  c1_info[39].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[39].fileTimeLo = 1323170578U;
  c1_info[39].fileTimeHi = 0U;
  c1_info[39].mFileTimeLo = 0U;
  c1_info[39].mFileTimeHi = 0U;
  c1_info[40].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/external/eml_blas_xdot.m";
  c1_info[40].name = "eml_refblas_xdot";
  c1_info[40].dominantType = "double";
  c1_info[40].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c1_info[40].fileTimeLo = 1299076772U;
  c1_info[40].fileTimeHi = 0U;
  c1_info[40].mFileTimeLo = 0U;
  c1_info[40].mFileTimeHi = 0U;
  c1_info[41].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdot.m";
  c1_info[41].name = "eml_refblas_xdotx";
  c1_info[41].dominantType = "char";
  c1_info[41].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[41].fileTimeLo = 1299076774U;
  c1_info[41].fileTimeHi = 0U;
  c1_info[41].mFileTimeLo = 0U;
  c1_info[41].mFileTimeHi = 0U;
  c1_info[42].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[42].name = "eml_scalar_eg";
  c1_info[42].dominantType = "double";
  c1_info[42].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_scalar_eg.m";
  c1_info[42].fileTimeLo = 1286818796U;
  c1_info[42].fileTimeHi = 0U;
  c1_info[42].mFileTimeLo = 0U;
  c1_info[42].mFileTimeHi = 0U;
  c1_info[43].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[43].name = "eml_index_class";
  c1_info[43].dominantType = "";
  c1_info[43].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[43].fileTimeLo = 1323170578U;
  c1_info[43].fileTimeHi = 0U;
  c1_info[43].mFileTimeLo = 0U;
  c1_info[43].mFileTimeHi = 0U;
  c1_info[44].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[44].name = "eml_index_minus";
  c1_info[44].dominantType = "double";
  c1_info[44].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c1_info[44].fileTimeLo = 1286818778U;
  c1_info[44].fileTimeHi = 0U;
  c1_info[44].mFileTimeLo = 0U;
  c1_info[44].mFileTimeHi = 0U;
  c1_info[45].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_minus.m";
  c1_info[45].name = "eml_index_class";
  c1_info[45].dominantType = "";
  c1_info[45].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[45].fileTimeLo = 1323170578U;
  c1_info[45].fileTimeHi = 0U;
  c1_info[45].mFileTimeLo = 0U;
  c1_info[45].mFileTimeHi = 0U;
  c1_info[46].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[46].name = "eml_index_times";
  c1_info[46].dominantType = "coder.internal.indexInt";
  c1_info[46].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c1_info[46].fileTimeLo = 1286818780U;
  c1_info[46].fileTimeHi = 0U;
  c1_info[46].mFileTimeLo = 0U;
  c1_info[46].mFileTimeHi = 0U;
  c1_info[47].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_times.m";
  c1_info[47].name = "eml_index_class";
  c1_info[47].dominantType = "";
  c1_info[47].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[47].fileTimeLo = 1323170578U;
  c1_info[47].fileTimeHi = 0U;
  c1_info[47].mFileTimeLo = 0U;
  c1_info[47].mFileTimeHi = 0U;
  c1_info[48].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[48].name = "eml_index_plus";
  c1_info[48].dominantType = "coder.internal.indexInt";
  c1_info[48].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[48].fileTimeLo = 1286818778U;
  c1_info[48].fileTimeHi = 0U;
  c1_info[48].mFileTimeLo = 0U;
  c1_info[48].mFileTimeHi = 0U;
  c1_info[49].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_plus.m";
  c1_info[49].name = "eml_index_class";
  c1_info[49].dominantType = "";
  c1_info[49].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_index_class.m";
  c1_info[49].fileTimeLo = 1323170578U;
  c1_info[49].fileTimeHi = 0U;
  c1_info[49].mFileTimeLo = 0U;
  c1_info[49].mFileTimeHi = 0U;
  c1_info[50].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/blas/refblas/eml_refblas_xdotx.m";
  c1_info[50].name = "eml_int_forloop_overflow_check";
  c1_info[50].dominantType = "";
  c1_info[50].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m";
  c1_info[50].fileTimeLo = 1346510340U;
  c1_info[50].fileTimeHi = 0U;
  c1_info[50].mFileTimeLo = 0U;
  c1_info[50].mFileTimeHi = 0U;
  c1_info[51].context =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/eml/eml_int_forloop_overflow_check.m!eml_int_forloop_overflow_check_helper";
  c1_info[51].name = "intmax";
  c1_info[51].dominantType = "char";
  c1_info[51].resolved =
    "[ILXE]$matlabroot$/toolbox/eml/lib/matlab/elmat/intmax.m";
  c1_info[51].fileTimeLo = 1311255316U;
  c1_info[51].fileTimeHi = 0U;
  c1_info[51].mFileTimeLo = 0U;
  c1_info[51].mFileTimeHi = 0U;
}

static real_T c1_mpower
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_a)
{
  real_T c1_b_a;
  real_T c1_c_a;
  real_T c1_ak;
  real_T c1_d_a;
  real_T c1_e_a;
  real_T c1_b;
  c1_b_a = c1_a;
  c1_c_a = c1_b_a;
  c1_eml_scalar_eg(chartInstance);
  c1_ak = c1_c_a;
  c1_d_a = c1_ak;
  c1_eml_scalar_eg(chartInstance);
  c1_e_a = c1_d_a;
  c1_b = c1_d_a;
  return c1_e_a * c1_b;
}

static void c1_eml_scalar_eg
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static real_T c1_mod
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   real_T c1_x, real_T c1_y)
{
  real_T c1_r;
  real_T c1_xk;
  real_T c1_yk;
  real_T c1_b_x;
  real_T c1_b_y;
  real_T c1_c_x;
  real_T c1_d_x;
  real_T c1_e_x;
  real_T c1_f_x;
  real_T c1_g_x;
  real_T c1_h_x;
  real_T c1_i_x;
  real_T c1_c_y;
  real_T c1_j_x;
  real_T c1_d_y;
  real_T c1_b;
  real_T c1_e_y;
  real_T c1_k_x;
  real_T c1_l_x;
  c1_eml_scalar_eg(chartInstance);
  c1_xk = c1_x;
  c1_yk = c1_y;
  c1_b_x = c1_xk;
  c1_b_y = c1_yk;
  c1_eml_scalar_eg(chartInstance);
  if (c1_b_y == 0.0) {
    c1_r = c1_b_x;
  } else {
    c1_c_x = c1_b_y;
    c1_d_x = c1_c_x;
    c1_d_x = muDoubleScalarFloor(c1_d_x);
    if (c1_b_y == c1_d_x) {
      c1_e_x = c1_b_x / c1_b_y;
      c1_f_x = c1_e_x;
      c1_f_x = muDoubleScalarFloor(c1_f_x);
      c1_r = c1_b_x - c1_f_x * c1_b_y;
    } else {
      c1_r = c1_b_x / c1_b_y;
      c1_g_x = c1_r;
      c1_h_x = c1_g_x;
      c1_h_x = muDoubleScalarRound(c1_h_x);
      c1_i_x = c1_r - c1_h_x;
      c1_c_y = muDoubleScalarAbs(c1_i_x);
      c1_j_x = c1_r;
      c1_d_y = muDoubleScalarAbs(c1_j_x);
      c1_b = c1_d_y;
      c1_e_y = 2.2204460492503131E-16 * c1_b;
      if (c1_c_y <= c1_e_y) {
        c1_r = 0.0;
      } else {
        c1_k_x = c1_r;
        c1_l_x = c1_k_x;
        c1_l_x = muDoubleScalarFloor(c1_l_x);
        c1_r = (c1_r - c1_l_x) * c1_b_y;
      }
    }
  }

  return c1_r;
}

static void c1_b_eml_scalar_eg
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

static const mxArray *c1_g_sf_marshallOut(void *chartInstanceVoid, void
  *c1_inData)
{
  const mxArray *c1_mxArrayOutData = NULL;
  int32_T c1_u;
  const mxArray *c1_y = NULL;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_mxArrayOutData = NULL;
  c1_u = *(int32_T *)c1_inData;
  c1_y = NULL;
  sf_mex_assign(&c1_y, sf_mex_create("y", &c1_u, 6, 0U, 0U, 0U, 0), FALSE);
  sf_mex_assign(&c1_mxArrayOutData, c1_y, FALSE);
  return c1_mxArrayOutData;
}

static int32_T c1_g_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  int32_T c1_y;
  int32_T c1_i25;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_i25, 1, 6, 0U, 0, 0U, 0);
  c1_y = c1_i25;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void c1_f_sf_marshallIn(void *chartInstanceVoid, const mxArray
  *c1_mxArrayInData, const char_T *c1_varName, void *c1_outData)
{
  const mxArray *c1_b_sfEvent;
  const char_T *c1_identifier;
  emlrtMsgIdentifier c1_thisId;
  int32_T c1_y;
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)chartInstanceVoid;
  c1_b_sfEvent = sf_mex_dup(c1_mxArrayInData);
  c1_identifier = c1_varName;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_g_emlrt_marshallIn(chartInstance, sf_mex_dup(c1_b_sfEvent),
    &c1_thisId);
  sf_mex_destroy(&c1_b_sfEvent);
  *(int32_T *)c1_outData = c1_y;
  sf_mex_destroy(&c1_mxArrayInData);
}

static uint8_T c1_h_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_b_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl,
   const char_T *c1_identifier)
{
  uint8_T c1_y;
  emlrtMsgIdentifier c1_thisId;
  c1_thisId.fIdentifier = c1_identifier;
  c1_thisId.fParent = NULL;
  c1_y = c1_i_emlrt_marshallIn(chartInstance, sf_mex_dup
    (c1_b_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl), &c1_thisId);
  sf_mex_destroy(&c1_b_is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl);
  return c1_y;
}

static uint8_T c1_i_emlrt_marshallIn
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance,
   const mxArray *c1_u, const emlrtMsgIdentifier *c1_parentId)
{
  uint8_T c1_y;
  uint8_T c1_u0;
  sf_mex_import(c1_parentId, sf_mex_dup(c1_u), &c1_u0, 1, 3, 0U, 0, 0U, 0);
  c1_y = c1_u0;
  sf_mex_destroy(&c1_u);
  return c1_y;
}

static void init_dsm_address_info
  (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance)
{
}

/* SFunction Glue Code */
#ifdef utFree
#undef utFree
#endif

#ifdef utMalloc
#undef utMalloc
#endif

#ifdef __cplusplus

extern "C" void *utMalloc(size_t size);
extern "C" void utFree(void*);

#else

extern void *utMalloc(size_t size);
extern void utFree(void*);

#endif

void sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl_get_check_sum(mxArray
  *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(556378946U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(206516335U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2515728910U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(1073557345U);
}

mxArray
  *sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl_get_autoinheritance_info
  (void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs", "locals" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,5,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateString("GGx2rZhPAhm8v8fY0Ll7oG");
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(4);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"locals",mxCreateDoubleMatrix(0,0,mxREAL));
  }

  return(mxAutoinheritanceInfo);
}

mxArray *sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl_third_party_uses_info
  (void)
{
  mxArray * mxcell3p = mxCreateCellMatrix(1,0);
  return(mxcell3p);
}

static const mxArray
  *sf_get_sim_state_info_c1_InvertedDoublePendulumSystem_KobayashiEtAl(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  const char *infoEncStr[] = {
    "100 S1x4'type','srcId','name','auxInfo'{{M[1],M[9],T\"LQR_control\",},{M[1],M[10],T\"state\",},{M[1],M[4],T\"u\",},{M[8],M[0],T\"is_active_c1_InvertedDoublePendulumSystem_KobayashiEtAl\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 4, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
    chartInstance =
      (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *)
      ((ChartInfoStruct *)(ssGetUserData(S)))->chartInstance;
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (sfGlobalDebugInstanceStruct,
           _InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
           1,
           1,
           1,
           6,
           0,
           0,
           0,
           0,
           1,
           &(chartInstance->chartNumber),
           &(chartInstance->instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation
            (_InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
             chartInstance->chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (sfGlobalDebugInstanceStruct,
             _InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
             chartInstance->chartNumber,1);
          sf_debug_set_chart_event_thresholds(sfGlobalDebugInstanceStruct,
            _InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
            chartInstance->chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,2,0,1,"u");
          _SFD_SET_DATA_PROPS(1,1,1,0,"x");
          _SFD_SET_DATA_PROPS(2,1,1,0,"t");
          _SFD_SET_DATA_PROPS(3,1,1,0,"control_state");
          _SFD_SET_DATA_PROPS(4,2,0,1,"LQR_control");
          _SFD_SET_DATA_PROPS(5,2,0,1,"state");
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of MATLAB Function Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,2,0,0,0,0,0,3,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,3792);
        _SFD_CV_INIT_EML_IF(0,1,0,1758,1767,1822,1892);
        _SFD_CV_INIT_EML_IF(0,1,1,3094,3179,3351,3408);

        {
          static int condStart[] = { 3097, 3130, 3163 };

          static int condEnd[] = { 3126, 3159, 3179 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,1,0,3097,3179,3,0,&(condStart[0]),&(condEnd[0]),
                                5,&(pfixExpr[0]));
        }

        _SFD_CV_INIT_SCRIPT(0,1,3,0,0,0,0,0,7,3);
        _SFD_CV_INIT_SCRIPT_FCN(0,0,"hysteresis",0,-1,2103);
        _SFD_CV_INIT_SCRIPT_IF(0,0,1070,1143,1206,1557);
        _SFD_CV_INIT_SCRIPT_IF(0,1,1206,1298,1357,1557);
        _SFD_CV_INIT_SCRIPT_IF(0,2,1357,1432,1491,1557);

        {
          static int condStart[] = { 1073, 1110 };

          static int condEnd[] = { 1106, 1143 };

          static int pfixExpr[] = { 0, 1, -3 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,0,1073,1143,2,0,&(condStart[0]),&(condEnd[0]),
            3,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 1213, 1248, 1283 };

          static int condEnd[] = { 1244, 1279, 1298 };

          static int pfixExpr[] = { 0, 1, -3, 2, -3 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,1,1213,1298,3,2,&(condStart[0]),&(condEnd[0]),
            5,&(pfixExpr[0]));
        }

        {
          static int condStart[] = { 1364, 1400 };

          static int condEnd[] = { 1396, 1432 };

          static int pfixExpr[] = { 0, 1, -2 };

          _SFD_CV_INIT_SCRIPT_MCDC(0,2,1364,1432,2,5,&(condStart[0]),&(condEnd[0]),
            3,&(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);

        {
          unsigned int dimVector[2];
          dimVector[0]= 4;
          dimVector[1]= 1;
          _SFD_SET_DATA_COMPILED_PROPS(1,SF_DOUBLE,2,&(dimVector[0]),0,0,0,0.0,
            1.0,0,0,(MexFcnForType)c1_b_sf_marshallOut,(MexInFcnForType)NULL);
        }

        _SFD_SET_DATA_COMPILED_PROPS(2,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(3,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)NULL);
        _SFD_SET_DATA_COMPILED_PROPS(4,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);
        _SFD_SET_DATA_COMPILED_PROPS(5,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,0,
          (MexFcnForType)c1_sf_marshallOut,(MexInFcnForType)c1_sf_marshallIn);

        {
          real_T *c1_u;
          real_T *c1_t;
          real_T *c1_control_state;
          real_T *c1_LQR_control;
          real_T *c1_state;
          real_T (*c1_x)[4];
          c1_state = (real_T *)ssGetOutputPortSignal(chartInstance->S, 3);
          c1_LQR_control = (real_T *)ssGetOutputPortSignal(chartInstance->S, 2);
          c1_control_state = (real_T *)ssGetInputPortSignal(chartInstance->S, 2);
          c1_t = (real_T *)ssGetInputPortSignal(chartInstance->S, 1);
          c1_x = (real_T (*)[4])ssGetInputPortSignal(chartInstance->S, 0);
          c1_u = (real_T *)ssGetOutputPortSignal(chartInstance->S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c1_u);
          _SFD_SET_DATA_VALUE_PTR(1U, *c1_x);
          _SFD_SET_DATA_VALUE_PTR(2U, c1_t);
          _SFD_SET_DATA_VALUE_PTR(3U, c1_control_state);
          _SFD_SET_DATA_VALUE_PTR(4U, c1_LQR_control);
          _SFD_SET_DATA_VALUE_PTR(5U, c1_state);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(sfGlobalDebugInstanceStruct,
        _InvertedDoublePendulumSystem_KobayashiEtAlMachineNumber_,
        chartInstance->chartNumber,chartInstance->instanceNumber);
    }
  }
}

static const char* sf_get_instance_specialization(void)
{
  return "ij8ZDYPZpX3dhPfoY0e7gC";
}

static void sf_opaque_initialize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (void *chartInstanceVar)
{
  chart_debug_initialization
    (((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
      chartInstanceVar)->S,0);
  initialize_params_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
  initialize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_enable_c1_InvertedDoublePendulumSystem_KobayashiEtAl(void *
  chartInstanceVar)
{
  enable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_disable_c1_InvertedDoublePendulumSystem_KobayashiEtAl(void
  *chartInstanceVar)
{
  disable_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
}

static void sf_opaque_gateway_c1_InvertedDoublePendulumSystem_KobayashiEtAl(void
  *chartInstanceVar)
{
  sf_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
}

extern const mxArray*
  sf_internal_get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct* S)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_raw2high");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = (mxArray*)
    get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInfo->chartInstance);        /* raw sim ctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c1_InvertedDoublePendulumSystem_KobayashiEtAl();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_raw2high'.\n");
  }

  return plhs[0];
}

extern void
  sf_internal_set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct* S, const mxArray *st)
{
  ChartInfoStruct *chartInfo = (ChartInfoStruct*) ssGetUserData(S);
  mxArray *plhs[1] = { NULL };

  mxArray *prhs[4];
  int mxError = 0;
  prhs[0] = mxCreateString("chart_simctx_high2raw");
  prhs[1] = mxCreateDoubleScalar(ssGetSFuncBlockHandle(S));
  prhs[2] = mxDuplicateArray(st);      /* high level simctx */
  prhs[3] = (mxArray*)
    sf_get_sim_state_info_c1_InvertedDoublePendulumSystem_KobayashiEtAl();/* state var info */
  mxError = sf_mex_call_matlab(1, plhs, 4, prhs, "sfprivate");
  mxDestroyArray(prhs[0]);
  mxDestroyArray(prhs[1]);
  mxDestroyArray(prhs[2]);
  mxDestroyArray(prhs[3]);
  if (mxError || plhs[0] == NULL) {
    sf_mex_error_message("Stateflow Internal Error: \nError calling 'chart_simctx_high2raw'.\n");
  }

  set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInfo->chartInstance, mxDuplicateArray(plhs[0]));
  mxDestroyArray(plhs[0]);
}

static const mxArray*
  sf_opaque_get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct* S)
{
  return sf_internal_get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
    (S);
}

static void
  sf_opaque_set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct* S, const mxArray *st)
{
  sf_internal_set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl(S, st);
}

static void sf_opaque_terminate_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (void *chartInstanceVar)
{
  if (chartInstanceVar!=NULL) {
    SimStruct *S =
      ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
       chartInstanceVar)->S;
    if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
      sf_clear_rtw_identifier(S);
      unload_InvertedDoublePendulumSystem_KobayashiEtAl_optimization_info();
    }

    finalize_c1_InvertedDoublePendulumSystem_KobayashiEtAl
      ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
       chartInstanceVar);
    utFree((void *)chartInstanceVar);
    ssSetUserData(S,NULL);
  }
}

static void sf_opaque_init_subchart_simstructs(void *chartInstanceVar)
{
  initSimStructsc1_InvertedDoublePendulumSystem_KobayashiEtAl
    ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
     chartInstanceVar);
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c1_InvertedDoublePendulumSystem_KobayashiEtAl
      ((SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct*)
       (((ChartInfoStruct *)ssGetUserData(S))->chartInstance));
  }
}

static void mdlSetWorkWidths_c1_InvertedDoublePendulumSystem_KobayashiEtAl
  (SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    mxArray *infoStruct =
      load_InvertedDoublePendulumSystem_KobayashiEtAl_optimization_info();
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable(S,sf_get_instance_specialization(),infoStruct,
      1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop(S,sf_get_instance_specialization(),
                infoStruct,1,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop(S,
      sf_get_instance_specialization(),infoStruct,1,
      "gatewayCannotBeInlinedMultipleTimes"));
    sf_update_buildInfo(S,sf_get_instance_specialization(),infoStruct,1);
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,sf_get_instance_specialization(),
        infoStruct,1,3);
      sf_mark_chart_reusable_outputs(S,sf_get_instance_specialization(),
        infoStruct,1,3);
    }

    {
      unsigned int outPortIdx;
      for (outPortIdx=1; outPortIdx<=3; ++outPortIdx) {
        ssSetOutputPortOptimizeInIR(S, outPortIdx, 1U);
      }
    }

    {
      unsigned int inPortIdx;
      for (inPortIdx=0; inPortIdx < 3; ++inPortIdx) {
        ssSetInputPortOptimizeInIR(S, inPortIdx, 1U);
      }
    }

    sf_set_rtw_dwork_info(S,sf_get_instance_specialization(),infoStruct,1);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
  } else {
  }

  ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  ssSetChecksum0(S,(422664774U));
  ssSetChecksum1(S,(1262793038U));
  ssSetChecksum2(S,(4086750948U));
  ssSetChecksum3(S,(248139328U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
  ssSupportsMultipleExecInstances(S,1);
}

static void mdlRTW_c1_InvertedDoublePendulumSystem_KobayashiEtAl(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c1_InvertedDoublePendulumSystem_KobayashiEtAl(SimStruct *S)
{
  SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct *chartInstance;
  chartInstance = (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct
                   *)utMalloc(sizeof
    (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct));
  memset(chartInstance, 0, sizeof
         (SFc1_InvertedDoublePendulumSystem_KobayashiEtAlInstanceStruct));
  if (chartInstance==NULL) {
    sf_mex_error_message("Could not allocate memory for chart instance.");
  }

  chartInstance->chartInfo.chartInstance = chartInstance;
  chartInstance->chartInfo.isEMLChart = 1;
  chartInstance->chartInfo.chartInitialized = 0;
  chartInstance->chartInfo.sFunctionGateway =
    sf_opaque_gateway_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.initializeChart =
    sf_opaque_initialize_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.terminateChart =
    sf_opaque_terminate_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.enableChart =
    sf_opaque_enable_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.disableChart =
    sf_opaque_disable_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.getSimState =
    sf_opaque_get_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.setSimState =
    sf_opaque_set_sim_state_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.zeroCrossings = NULL;
  chartInstance->chartInfo.outputs = NULL;
  chartInstance->chartInfo.derivatives = NULL;
  chartInstance->chartInfo.mdlRTW =
    mdlRTW_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.mdlStart =
    mdlStart_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.mdlSetWorkWidths =
    mdlSetWorkWidths_c1_InvertedDoublePendulumSystem_KobayashiEtAl;
  chartInstance->chartInfo.extModeExec = NULL;
  chartInstance->chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance->chartInfo.storeCurrentConfiguration = NULL;
  chartInstance->S = S;
  ssSetUserData(S,(void *)(&(chartInstance->chartInfo)));/* register the chart instance with simstruct */
  init_dsm_address_info(chartInstance);
  if (!sim_mode_is_rtw_gen(S)) {
  }

  sf_opaque_init_subchart_simstructs(chartInstance->chartInfo.chartInstance);
  chart_debug_initialization(S,1);
}

void c1_InvertedDoublePendulumSystem_KobayashiEtAl_method_dispatcher(SimStruct
  *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_InvertedDoublePendulumSystem_KobayashiEtAl(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_InvertedDoublePendulumSystem_KobayashiEtAl(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_InvertedDoublePendulumSystem_KobayashiEtAl(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c1_InvertedDoublePendulumSystem_KobayashiEtAl_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
