function y = sat(x)
% sat gives the output for the system saturation, where sat(x) is given
% as sign(x) if |x| >= 1 and x if |x| < 1.
%
% Written by: Jrgen Herje Nilsen
% Date: 24.02.2014
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if abs(x) >= 1
    y = sign(x);
else
    y = x;
end